#!/usr/bin/perl

#    
#    Copyright 2010, 2011 Ole Skovgaard.
#    The scripts are distributed under the terms of the GNU General Public License
#    
#    
#    This file is part of R2R - From Read to Results.
#
#    R2R is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, version 3 of the License.
#
#    R2R is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with R2R.  If not, see <http://www.gnu.org/licenses/>.
#
#    Version: Release_0.950, November, 2011
#

Date();
tid();
$time_start = $tid;
print "
Program started at: $tid
";
open Eval_Reads_ini,"<Eval_Reads.ini" or die "No Eval_Reads.ini file found";
@Eval_Reads = <Eval_Reads_ini>;
close Eval_Reads_ini;

for $i ( 0 .. @Eval_Reads-1 ) {

	@OS = split "\t",$Eval_Reads[$i];
	$OS[0] =~ /(\$\w+)\s*=\s*([-\w\.\:\ \\\/]+)/;

	# Files:
	if ( $1 eq "\$fid_core"                )  { $fid_core = $2 }
	if ( $1 eq "\$repeat_csv"              )  { $repeat_csv = $2 } 
	if ( $1 eq "\$fa"                      )  { $fa = $2 }
	if ( $1 eq "\$anno"                    )  { $anno = $2 }
	if ( $1 eq "\$snp_bed"                 )  { $snp_bed = $2 }

	# General Variables:
	$var = $2;
	$var =~ s/ //g; # spaces are not allowed in variables
	
	if ( $1 eq "\$qbase"                   )  { $qbase = $2 }
	if ( $1 eq "\$start_no"                )  { $start_no = $2 }

	# Script specific variables:
	if ( $1 eq "\$print_reads"             )  { $print_reads = $2 }
	if ( $1 eq "\$print_read_density"      )  { $print_read_density = $2 }
	if ( $1 eq "\$print_mut_quality"       )  { $print_mut_quality = $2 }

	if ( $1 eq "\$panel_width"             )  { $panel_width = $2 }
	if ( $1 eq "\$seq_overlap"             )  { $seq_overlap = $2 }
	if ( $1 eq "\$min_pr"                  )  { $min_pr = $2 }
	if ( $1 eq "\$ind_min"                 )  { $ind_min = $2 }
	if ( $1 eq "\$mut_min"                 )  { $mut_min = $2 }
	if ( $1 eq "\$mut_freq_min"            )  { $mut_freq_min = $2 }
	if ( $1 eq "\$ID_limit"                )  { $ID_limit= $2 }
	if ( $1 eq "\$no_mut_in_repeats"       )  { $no_mut_in_repeats = $2 }
	
	if ( $1 eq "\$check_translation"       )  { $check_translation = $2 }
	if ( $1 eq "\$read_dist"               )  { $read_dist = $2 }
	
	if ( $1 eq "\$PE_reads"                )  { $PE_reads = $2 }
	if ( $1 eq "\$PE_dist"                 )  { $PE_dist = $2 }
	if ( $1 eq "\$PE_dist_var"             )  { $PE_dist_var = $2 }
	if ( $1 eq "\$PE_short_max_dist"       )  { $PE_short_max_dist       = $2 }
	if ( $1 eq "\$PE_short_reads_in_dist"  )  { $PE_short_reads_in_dist  = $2 }
	if ( $1 eq "\$PE_long_min_dist"        )  { $PE_long_min_dist        = $2 }
	if ( $1 eq "\$PE_long_reads_in_dist"   )  { $PE_long_reads_in_dist   = $2 }
	if ( $1 eq "\$PE_unpair_min_dist"      )  { $PE_unpair_min_dist      = $2 }
	if ( $1 eq "\$PE_unpair_reads_in_dist" )  { $PE_unpair_reads_in_dist = $2 }	
}

$info_lineno = 20;   # Max no of lines in each of annotation, SNP's and like information lines
$match = $fid_core."_rd_srt.bex";
$mut =   $fid_core."_mo_srt.bex";

$screen = select (); # Saves the value for default output (to the screen), used after flushing of output files.
binmode out;   # Ensures that System independent Unix "LF" (0A) is used for New Line.

#			open(tst1, ">test1.txt");
#			open(tst2, ">test2.txt");		
#			open(tst3, ">test3.txt");		
#			open(tst4, ">test4.txt");		
#			open(tst5, ">test5.txt");		
#     unless (opendir test, test ) { mkdir "test"; }
#
#			select (tst1);    $| = 1;     # Don't buffer print
#			select (tst2);    $| = 1;     # Don't buffer print   
#			select (tst3);    $| = 1;     # Don't buffer print   
#			select (tst4);    $| = 1;     # Don't buffer print   
#			select (tst5);    $| = 5;     # Don't buffer print
	
select ($screen);

open Match,"<$match" or die "File $match with Matching reads is missing \ninspect the \$fid_core line in the Eval_Reads.ini file  \n" ;
open Mut,"<$mut" or die "File with Mut/InDel reads is missing \ninspect the \$fid_core line in  the Eval_Reads.ini file  \n" ;
open Repeat_csv,"<$repeat_csv" or print "Repeat file $repeat_csv was not found; \ninspect the \$repeat_csv line in the Eval_Reads.ini file  \n";
open Seq,"<$fa" or die "File $fa with reference sequence is missing\ninspect the \$fa line in the Eval_Reads.ini file  \n";
open Anno,"<$anno"  or print "No annotion file: $anno;\ninspect the \$anno line in the Eval_Reads.ini file  \n";
			
$chr_size = find_chr_size (); # Depends on open Seq.
initialize_html();  # Intialize left margins, font colors and html bit's & pieces

close Eval_Reads_ini, Match, Mut, Repeat, Seq, Anno, un_paired, sh_paired, lo_paired, ;

	unless ($qbase)    {print "\nError: No \$qbase was given for this experiment; correct R2R_read.ini\n(\$qbase is the base number for quality\n recommende values are 33 for FastQ data and 64 for Illumina data) \n" ; exit}
	$qbase =~ s/\s//;
	if ($qbase =~ /\D+/)    {print "\nError: \$qbase = \'$qbase\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n(\$qbase is the base number for quality\n recommended values are 33 for FastQ data and 64 for Illumina data) \n" ; exit}
	unless ($qbase==33 or $qbase==64)    {print "\nWarning: \$qbase is normally set to 33 for FastQ data and 64 for Illumina data\n" }

	$start_no =~ s/\s//;
	if ($start_no =~ /\D+/)    {print "\nError: \$start_no = \'$start_no\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n" ; exit}
	unless (0 <= $start_no )    {print "\nWarning: \\$start_no = \'$start_no\' is less than 0 \nThis makes sense in special cases only.\n" }

	unless ($panel_width)    {print "\nError: No \$panel_width was given for this experiment; correct Eval_reads.ini\n\$panel_width is the width of each panel in bp\n recommende values are 100, 500 or 1000\n" ; exit}
	$panel_width =~ s/\s//;
	if ($panel_width =~ /\D+/)    {print "\nError: \$panel_width = \'$panel_width\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$panel_width is the width of each panel in bp\n recommended values are 100, 500 or 1000\n" ; exit}
	unless ( 10 <= $panel_width and $panel_width <= 5000)    {print "\nWarning: \$panel_width = \'$panel_width\' is normally set to 100, 500 or 1000\n" }

	unless ($seq_overlap)    {print "\nError: No \$seq_overlap was given for this experiment; correct Eval_reads.ini\n\$seq_overlap is the number of bp subtracted from each end of \nmatching reads before confirming the reference sequence\n recommended value is between 3 and 10\n" ; exit}
	$seq_overlap =~ s/\s//;
	if ($seq_overlap =~ /\D+/)    {print "\nError: \$seq_overlap = \'$seq_overlap\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$seq_overlap is the number of bp subtracted from each end of \nmatching reads before confirming the reference sequence\n recommende value is between 3 and 10\n" ; exit}
	unless ( 3 <= $seq_overlap and $seq_overlap <= 10)    {print "\nWarning: \$seq_overlap = \'$seq_overlap\' is normally set between 3 and 10\n" }

	unless ($min_pr)    {print "\nError: No \$min_pr was given for this experiment; correct Eval_reads.ini\n\$min_pr is the minimum distance between consequtive \nmatching reads before printing them in the panel\n\$min_pr does not influence any other statistics\n recommended value is 0 or 1\n" ; exit}
	$min_pr =~ s/\s//;
	if ($min_pr =~ /\D+/)    {print "\nError: \$min_pr = \'$min_pr\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$min_pr is the minimum distance between consequtive \nmatching reads before printing them in the panel\n\$min_pr does not influence any other statistics\n recommended value is 0 or 1\n" ; exit}
	unless ( 0 <= $min_pr and $min_pr <= 1)    {print "\nWarning: \$min_pr = \'$min_pr\' is normally set as 0 or 1\n" }

	unless ($ind_min)    {print "\nError: No \$ind_min was given for this experiment; correct Eval_reads.ini\n\$ind_min is the minimum number of InDel reads at one \nposition to be reported\n recommended value is 2 to 10\n" ; exit}
	$ind_min =~ s/\s//;
	if ($ind_min =~ /\D+/)    {print "\nError: \$ind_min = \'$ind_min\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$ind_min is the minimum number of InDel reads at one \nposition to be reported\n recommended value is 2 to 10\n" ; exit}
	unless ( 2 <= $ind_min and $ind_min <= 10)    {print "\nWarning: \$ind_min = \'$ind_min\' is normally set between 2 and 10\n" }

	unless ($mut_min)    {print "\nError: No \$mut_min was given for this experiment; correct Eval_reads.ini\n\$mut_min is the minimum number of mutations at one \nposition to be reported\n recommended value is 2 to 5\n" ; exit}
	$mut_min =~ s/\s//;
	if ($mut_min =~ /\D+/)    {print "\nError: \$mut_min = \'$mut_min\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$mut_min is the minimum number of mutations at one \nposition to be reported\n recommended value is 2 to 5\n" ; exit}
	unless ( 2 <= $mut_min and $mut_min <= 5)    {print "\nWarning: \$mut_min = \'$mut_min\' is normally set between 2 and 5\n" }

	unless ($mut_freq_min)    {print "\nError: No \$mut_freq_min was given for this experiment; correct Eval_reads.ini\n\$mut_freq_min is the minimum frequency of mutations to matching reads at one \nposition to be reported\n recommended value is from 0.1 to 2\n" ; exit}
	$mut_freq_min =~ s/\s//;
	unless ($mut_freq_min/1)    {print "\nError: \$mut_freq_min = \'$mut_freq_min\' should be a number \nand should be followed by \';\'; correct Eval_Reads.ini\n\$mut_freq_min is the minimum frequency of mutations to matching reads at one \nposition to be reported\n recommended value is from 0.1 to 2\n" ; exit}
	unless ( 0.01 <= $mut_freq_min and $mut_freq_min <= 5)    {print "\nWarning: \$mut_freq_min = \'$mut_freq_min\'; suggested values are 1 to 2 for haploid, 0.1 - 0.3 for diploid. \n" }

	unless ($ID_limit)    {print "\nError: No \$ID_limit was given for this experiment; correct Eval_reads.ini\n\$ID_limit is the maximal relative deviation in quality across an InDel \nposition to be reported\n recommended value range from 0.1 to 1\n" ; exit}
	$ID_limit =~ s/\s//;
	unless ($ID_limit/1)    {print "\nError: \$ID_limit = \'$ID_limit\' should be a (decimal) number \nand should be followed by \';\'; correct Eval_Reads.ini\n\$ID_limit is the maximal relative deviation in quality across an InDel \nposition to be reported\n recommended value range from 0.1 to 1\n" ; exit}
	unless ( 0.1 <= $ID_limit and $ID_limit <= 1)    {print "\nWarning: \$ID_limit = \'$ID_limit\'; suggested value range from 0.1 to 1\n" }

	unless ($read_dist)    {print "\nError: No \$read_dist was given for this experiment; correct Eval_reads.ini\n\$read_dist is the minimum number of spaces between each read in the panels. \nSuggested value ~8.	\n" ; exit}
	$read_dist =~ s/\s//;
	if ($read_dist =~ /\D+/)    {print "\nError: \$read_dist = \'$read_dist\' should contain digits only and be followed by \';\'; correct Eval_Reads.ini\n\$read_dist is the minimum number of spaces between each read in the panels. \nSuggested value ~8.	\n" ; exit}
	unless ( 4 <= $read_dist and $read_dist <= 12)    {print "\nWarning: \$read_dist = \'$read_dist\'; suggested value ~8\n" }


$nop = int ($chr_size / $panel_width); # This may be approximate and cause rare errors when linking from the first to the last panel or v.v.
$nopp = $nop + 1; # since $nop is rounded towards 0 and panel numbers starts with 0;
$chr_size_p = sub_print_No ($chr_size);
print "
Match file: 
   $match;

Mut+InDel file: 
   $mut;

Repeat file: 
   $repeat_csv;

FASTA reference sequence file: 
   $fa;

Annotation file: 
   $anno;

SNP file: 
   $snp_bed;

Coordinate of 1'st base:    $start_no
Size of chromosome is:      $chr_size_p bp.
Total number of panels is:  $nopp
" ;

unless (opendir html, html ) { mkdir "html"; }
open (I_Report_html, ">$fid_core.Index.htm") or die "Can't open I_Report_html";
print I_Report_html "<p>The data in: $match <br>was analyzed on the $fa sequence<br>and the annotations in $anno<br>at $date; $time_start<br>Program: $0</p>\n<pre>";
print I_Report_html "       panel No:            From:           To:      Genes: \n";

open(MUT_Report_html, ">$fid_core.Report_Mutations.htm");
open(UNC_Report_html, ">$fid_core.Report_Unconfirmed_bases.htm");
print MUT_Report_html "<pre>The data in: $match \nwas analyzed on the $fa sequence\nand the annotations in $anno \nat $date; $time_start\nProgram: $0\n";

if  ($no_mut_in_repeats) {
	print MUT_Report_html "$bold"."Mut/InDels in repeat regions are not reported since the variable \$no_mut_in_repeats = '$no_mut_in_repeats' is set\n$bold_";
}
print UNC_Report_html "<pre>The data in: $match \nwas analyzed on the $fa sequence\nand the annotations in $anno \nat $date; $time_start\nProgram: $0\n";

open(AUX_Report, ">$fid_core.Report_AUX.txt");
open(Read_Report, ">$fid_core.Report_Reads.csv");
	
select (I_Report_html);    $| = 1;     # Don't buffer print
select (Read_Report_html); $| = 1;     # Don't buffer print
select (MUT_Report_html);  $| = 1;     # Don't buffer print
select (UNC_Report_html);  $| = 1;     # Don't buffer print
select (Read_Report);      $| = 1;     # Don't buffer print
select ($screen);

print AUX_Report "The data in: $match \nwas analyzed on the $fa sequence\nand the annotations in $anno \nat $date; $time_start\nProgram: $0\n";
print Read_Report "\t\tNumber of reads per panel for frequency analysis:\t\n";

if ($start_no) {
	$panel_no = $panel_no_start = int($start_no / $panel_width) ;
	$seq_sync = $start_no - $panel_no * $panel_width;
}
else {$panel_no = $panel_no_start = 0}

print MUT_Report_html "
Min number of InDel reads to report:  $ind_min
Min number of Mutation reads to report:  $mut_min
Min frequency of mut reads cmp to matching reads:  $mut_freq_min
Min overlap between two consecutive reads to confirm overlapping sequence reads: $seq_overlap
Min distance for printing & analysing reads; 0 prints all reads: $min_pr
";
print MUT_Report_html "
       panel_No  P_Pos   Mut/InDel     #Mut  #Mut+  #Mut- #Match ID_qual Repeat  SNP?  Suggested mutation(s)      Annotation(s)\n";

print UNC_Report_html "
       panel_No   P_Pos    Type            Start Pos.   End Pos.   Length       Annotation(s)\n";

# Initialization of selected variables with explanations
$baseno = $start_no;		# The overall coordinate for panel layouts and analysis
$repeat_char = "+";

open(Match,"<$match") or print "Warning: could not open match file;\n";
open(Mut,"<$mut") or print "Warning: could not open mut/InDel file;\n";
open(Repeat_csv,"<$repeat_csv") or print "Warning: could not open repeat file;\n";
open(Seq,"<$fa") or print "Warning: could not open FASTA sequence file;\n";
if ($snp_bed) { open(SNP_bed,"<$snp_bed") or print "Warning: could not open SNP_bed  file;\n" }
open(Anno,"<$anno") or print "Warning: could not open annotation file \$anno = $anno;\n";

read_match (0);  # Reads many mathing read's to be placed; when empty it must be refilled
read_mut (0);  # mutations are also read by read_sort# Reads many mutation read's to be placed; when empty it must be refilled
read_seq (0); 	# Reads many lines of nt's; when empty it must be refilled
if ($PE_reads) {		PE_read ()	}		
if ($anno) {read_anno (0)} 	# Reads many lines of annotations; when empty it must be refilled
if ($snp_bed) {read_SNP(0)}

if ($PE_reads) {
	# PE Statistics:
	push (@PE_short_plus,0);
	push (@PE_short_minus,0);
	open (PE_Report, ">$fid_core.Report_PairedEnd.htm");
	print PE_Report "
	<pre>The data in: $match \nwas analyzed on the $fa sequence\nand the annotations in $anno \nat $date; $time_start\nProgram: $0\n
	Paired End analysis:
	If the distance between $fc_red$PE_short_reads_in_dist$f_end Short PE reads is greater than $fc_red$PE_short_max_dist,$f_end then report;
	Low conc of normal PE reads indicates InDel's or repeat regions

	If the distance between $fc_red$PE_long_reads_in_dist$f_end PE long reads is less than $fc_red$PE_long_min_dist,$f_end then report;
	High conc of long PE reads indicate Deletions or rearrangements.

	If the distance between $fc_red$PE_unpair_reads_in_dist$f_end PE unpaired reads is less than $fc_red$PE_unpair_min_dist,$f_end then report;
	High conc of unpaired PE reads indicate Inserition og new DNA

	panel_No panel_Pos     Observation                          1. rd   Last rd  Distance  Repeat  \n";
}

# Add n's in front of $seq to synchronize the first panel:
$seq_init = " " x $seq_sync ;
$seq = $seq_init . $seq;

# print + strand aligns:
	# initialise StrAl arrays:
$empty = " " x ($panel_width+200) ; # An empty string
for $i (0 .. $panel_width ) { $empty_pv[$i]=0 } # An empty array; width panel_width
for $i (0 .. $panel_width+200 ) { $empty[$i]=0 } # An empty array; width panel_width+200

for $i ( 0 .. $info_lineno ){
	$AnnoPrint[$i]= $empty ;		
	$AnnoPrint_prev[$i] = "  ";
	$StrAlSNP_bed[$i]= $empty ;
}
$StrAlSNP_bed_panel =  $empty;

$StrAlRepeat = " " x $chr_size  ;
while (<Repeat_csv>) {
	my @rep = split "\t", $_ ;
	my $rep_start = $rep[0] - $start_no +1;
	my $rep_length = $rep[1] - $rep[0];
	my $rep_replace = $repeat_char x $rep_length;
	substr ( $StrAlRepeat , $rep_start, $rep_length, $rep_replace );
}

$Repeat_total = $StrAlRepeat = $seq_init . $StrAlRepeat;  # Repeats should no longer be truncated after panel print.

$p = $m = 0;
$Anno_no = 0;
@match_p_density = @match_m_density = @empty;
@match_mut_density = @match_mut_p_density = @match_mut_m_density = @match_indel_density = @match_indel_p_density = @match_indel_m_density = @empty;
@anno_pos = @empty;


MAIN: while ( length $seq > 10 ) {      # Main loop of program, stops when no more reference sequence can be read
	# build a panel;
	# build matching reads
	$pos_corr = ($panel_no * $panel_width);  #   0-based coordinate of the first base of each panel		
	$reg_start = ($panel_no*$panel_width > $start_no? $panel_no*$panel_width : $start_no);
	$reg_end   = ($panel_no+1)*$panel_width-1 < $chr_size? ($panel_no+1)*$panel_width-1 : $chr_size;

	$m = $p = 0;
	splice (@MutSeq,0,$panel_width);
	while ( $match[0][0] <= ( $panel_no + 1 ) * $panel_width  ) {
		$match_panel_pos = $match[0][0]-$pos_corr;
		$rd_length = $match[0][6];
		if ($rd_length > $rd_length_max) { $rd_length_max = $rd_length }
		
		if ($match[0][2] eq "+") {
			$p = 0;						
			unless ( $StrAlPlus[$p] ) { $StrAlPlus[$p] = $empty }
			$offset = ($match_panel_pos - $read_dist > 0? $match_panel_pos - $read_dist : 0);
			while (substr ( $StrAlPlus[$p] , $offset, -1 )  =~  /\S+/) {
				$p++ ;
				unless ( $StrAlPlus[$p] )   { $StrAlPlus[$p] = $empty }
			}
			if ($match[0][0] >= $m_p_prev + $min_pr) {
				substr ( $StrAlPlus[$p] , $match[0][0]-$pos_corr, $rd_length, $match[0][4] );
				$m_p_prev = $match[0][0] ;
				$p++;
			}
			#Build density of matching + reads
			for $i ($seq_overlap .. $rd_length-$seq_overlap-1) {
				$x = $i+$match[0][0]-$pos_corr;
				$match_p_density[$x]++;
			}
			# Gamma statistics:
			$start_p_density[$match[0][0]-$pos_corr]++;
		} # end if "+"

		if ($match[0][2] eq "-") {
			$m = 0;
			unless ( $StrAlMinus[$m] ) { $StrAlMinus[$m] = $empty }
			$offset = ($match_panel_pos - $read_dist > 0? $match_panel_pos - $read_dist : 0);
			while (substr ( $StrAlMinus[$m] , $offset, -1 )  =~  /\S+/) {
				$m++ ;
				unless ( $StrAlMinus[$m] )   { $StrAlMinus[$m] = $empty }
			}
			if ($match[0][0] >= $m_m_prev + $min_pr) {
				$match[0][4] = revComp ($match[0][4]);
				substr ( $StrAlMinus[$m] , $match[0][0]-$pos_corr, $rd_length, $match[0][4] )  ;
				$m_m_prev = $match[0][0] ;
				$m++;
			}
			#Build density of matching - reads
			for $i ($seq_overlap .. $rd_length-$seq_overlap-1) {
				$x = $i+$match[0][0]-$pos_corr;
				$match_m_density[$x]++;
			}
			# Gamma statistics:
			$start_m_density[$match[0][0]-$pos_corr]++;
		} # end if "-"
		shift @match;
	}	# End while ( $match[0][0] <= ( $panel_no + 1 ) * $panel_width  )

	# build mut + indels
	$m = $p = 0;
	
	while ( $mut[0][0] <= ( $panel_no + 1 ) * $panel_width  ) {
		$mut_panel_pos = $mut[0][0]-$pos_corr;
		$rd_length = $mut[0][6];
		if ($rd_length > $rd_length_max) { $rd_length_max = $rd_length }
		$mut[0][5]=~tr/<>/==/;  # removes < & > from quality, these char's conflicts with HTML, average to "="
		if ($mut[0][2] eq "+") {
			$ph = 0;
			unless ( $StrAlMutPlus[$ph] ) { $StrAlMutPlus[$ph] = $empty }
			$offset = ($mut_panel_pos - $read_dist > 0? $mut_panel_pos - $read_dist : 0);
			while (substr ( $StrAlMutPlus[$ph] , $offset, -1 )  =~  /\S+/) {
				$ph++ ;
				unless ( $StrAlMutPlus[$ph] )   { $StrAlMutPlus[$ph] = $empty }
			}
			$x = $mut[0][4] . " " . $mut[0][2].$mut[0][7] ;
			# sub_str ( $StrAlMutPlus[$ph] , $mut_panel_pos, $rd_length, $x );
			substr ( $StrAlMutPlus[$ph], $mut_panel_pos, $rd_length, $x );
			if ($print_mut_quality) {
				unless ( $StrAlMutPlus[$ph+1] ) { $StrAlMutPlus[$ph+1] = $empty }
				$x = $mut[0][5] . " " . $mut[0][2].$mut[0][7] ;
				substr ( $StrAlMutPlus[$ph+1] , $mut_panel_pos, $rd_length, $x );
			}  #End 		if ($print_mut_quality)

			# Extract coordinates to mark as non-matching AND extraction of the mutant nucleotide
			@mmX = split (" ", $mut[0][7]);
			$mmX = shift @mmX;  # saves "MMn:"
			@mmX = reverse @mmX;
			$mmX =~ /MM(\d)/;
			if ( $1 > 0 && $1 <8 ){
				while(@mmX){
					$readpos = pop @mmX;
					$mp[0] = $mut_panel_pos + $readpos;
					$mp[1] = $mp[0] +1;
					$mut_pos_p[$ph] = $mut_pos_p[$ph]."\t".$mp[0]." ".$mp[1];
					if ($print_mut_quality) {$mut_pos_p[$ph+1] = $mut_pos_p[$ph]}
					$MutSeq[$mp[0]] .= substr ($mut[0][4],$readpos,1);
				}
			}
			if ($mmX eq "MM8:" ){
				$mp[0] = $mut_panel_pos + $mmX[0];
				$mp[1] = $mut_panel_pos + $rd_length;
				$mut_pos_p[$ph] = $mut_pos_p[$ph]."\t".$mp[0]." ".$mp[1];
				if ($print_mut_quality) {$mut_pos_p[$ph+1] = $mut_pos_p[$ph]}
				push_qual ($mut_panel_pos, $mp[0], $mut[0][5], $mmX);
			}
			if ($mmX eq "MM9:" ){
				$mp[0] = $mut_panel_pos ;
				$mp[1] = $mut_panel_pos + $mmX[0]+1;   ###??? temp +1 correction??
				$mut_pos_p[$ph] = $mut_pos_p[$ph]."\t".$mp[0]." ".$mp[1];
				if ($print_mut_quality) {$mut_pos_p[$ph+1] = $mut_pos_p[$ph]}		
				push_qual ($mut_panel_pos, $mp[1], $mut[0][5], $mmX);
			}
		}  # End 	if ($mut[0][2] eq "+")

		if ($mut[0][2] eq "-") {
			$mh = 0;
			unless ( $StrAlMutMinus[$mh] ) { $StrAlMutMinus[$mh] = $empty }
			$offset = ($mut_panel_pos - $read_dist > 0? $mut_panel_pos - $read_dist : 0);
			while (substr ( $StrAlMutMinus[$mh] , $offset, -1 )  =~  /\S+/) {
				$mh++ ;
				unless ( $StrAlMutMinus[$mh] )   { $StrAlMutMinus[$mh] = $empty }
			}
			# "RevComp" the mut pos'
			@mmX = split (" ", $mut[0][7]);
			$mmX = shift @mmX;  # saves "MMn:"
			@mmX = reverse @mmX ;
			foreach $mut_pos(@mmX) {$mut_pos = $rd_length - $mut_pos - 1}
			$mut[0][7] = join " ", $mmX, @mmX;
			$mut[0][4] = revComp ($mut[0][4]);
			$x = ($mut[0][4]) . " " .$mut[0][2].$mut[0][7]  ;
			# sub_str ( $StrAlMutMinus[$mh], $mut_panel_pos, $rd_length, $x );
			substr ( $StrAlMutMinus[$mh], $mut_panel_pos, $rd_length, $x );
			if ($print_mut_quality) {
				unless ( $StrAlMutMinus[$mh+1] ) { $StrAlMutMinus[$mh+1] = $empty }
				$mut[0][5] = reverse $mut[0][5];
				$x = $mut[0][5] . " " . $mut[0][2].$mut[0][7] ;
				substr ( $StrAlMutMinus[$mh+1] , $mut_panel_pos, $rd_length, $x );
			}

			# Extract coordinates to mark as non-mathing
			@mmX = split (" ", $mut[0][7]);
			$mmX = shift @mmX;  # saves "MMn:"
			@mmX = reverse @mmX;
			$mmX =~ /MM(\d)/;
			
			if ( $1 > 0 && $1 <8 ){
				while(@mmX){
					$readpos = pop @mmX;
					$mp[0] = $mut_panel_pos + $readpos;
					$mp[1] = $mp[0] +1;
					$mut_pos_m[$mh] = $mut_pos_m[$mh]."\t".$mp[0]." ".$mp[1];
					if ($print_mut_quality) {$mut_pos_m[$mh+1] = $mut_pos_m[$mh]}
					$MutSeq[$mp[0]] .= substr ($mut[0][4],$readpos,1);
				}
			}
			if ($mmX eq "MM8:" ){
				$mp[0] = $mut_panel_pos + $mmX[0];
				$mp[1] = $mut_panel_pos + $rd_length;
				$mut_pos_m[$mh] = $mut_pos_m[$mh]."\t".$mp[0]." ".$mp[1];
				if ($print_mut_quality) {$mut_pos_m[$mh+1] = $mut_pos_m[$mh]}	
				push_qual ($mut_panel_pos, $mp[0], $mut[0][5], $mmX);
			}
			if ($mmX eq "MM9:" ){
				$mp[0] = $mut_panel_pos ;
				$mp[1] = $mut_panel_pos + $mmX[0]+1;  ###??? temp +1 correction??
				$mut_pos_m[$mh] = $mut_pos_m[$mh]."\t".$mp[0]." ".$mp[1];
				if ($print_mut_quality) {$mut_pos_m[$mh+1] = $mut_pos_m[$mh]}	
				push_qual ($mut_panel_pos, $mp[1], $mut[0][5], $mmX);
			}
		}  # End 	if ($mut[0][2] eq "-")

		#Build density of mutation and indel reads
		# + and - values are added up
		#For mutation reads the mut position(s) only are included
		#For Indels a "Hot-zone" defined as position +/- nt's is included
		
		# $1 = "";
		$mut[0][7] =~ /MM(\w):/;
		@m_pos = split " ",$mut[0][7];
		
		if ( $1 < 8 && $1 > 0) {
			for $i (1..@m_pos-1) {				
				$x = $mut[0][0]-$pos_corr+$m_pos[$i];
				$match_mut_density[$x]++;
				if ($mut[0][2] eq "+") {
					$match_mut_p_density[$x]++;
				}
				if ($mut[0][2] eq "-") {
					$match_mut_m_density[$x]++;
				}			
			}
		}
		if ( $1 == 8 ) {
			$x = $mut[0][0]-$pos_corr+$m_pos[1];
			$match_indel_density[$x]++;
			if ($mut[0][2] eq "+") {
				$match_indel_p_density[$x]++;
			}
			if ($mut[0][2] eq "-") {
				$match_indel_m_density[$x]++;
			}			
		}
		if ( $1 == 9 ) {
			$x = $mut[0][0]-$pos_corr+$m_pos[1]+1; ###??? temp +1 correction??
			$match_indel_density[$x]++;
			if ($mut[0][2] eq "+") {
				$match_indel_p_density[$x]++;
			}
			if ($mut[0][2] eq "-") {
				$match_indel_m_density[$x]++;
			}			
		}
		shift @mut;
	}	# End while ( $mut[0][0] <= ( $panel_no + 1 ) * $panel_width  )

	for $i ( 0 .. @StrAlMutPlus-1 )  {
		if ( $StrAlMutPlus[$i]=~  /\S+/)  { 
			$panelStrAlMutPlus[$i]  = substr $StrAlMutPlus[$i],  0, $panel_width ; 
		}  
	}
	for $i ( 0 .. @StrAlMutMinus-1 ) { 
		if ( $StrAlMutMinus[$i]=~  /\S+/) { 
			$panelStrAlMutMinus[$i] = substr $StrAlMutMinus[$i], 0, $panel_width ; 
		}  
	}

# Build Paired End reads and Statistics
	if ($PE_reads) {
		@short_pair = sort {$a cmp $b} @short_pair;
		$sh_pair = shift @short_pair;
		@sh_pair = split "\t", $sh_pair ;	
		if ( $sh_pair[0] > ( $panel_no + 1 ) * $panel_width ) {	
			push @short_pair, $sh_pair;
			$sh_pair = "";
			@sh_pair = "";
		}	
		while ( 0 < $sh_pair[0] && $sh_pair[0] <= ( $panel_no + 1 ) * $panel_width ) {
			if ( $sh_pair[1] eq "+ -" || $sh_pair[1] eq "+ +" ) {
				$i = 0;
				unless ( $panel_PE_short_Plus[$i] ) { $panel_PE_short_Plus[$i] = $empty }
				$offset = ($sh_pair[0]-$pos_corr-4 > 0? $sh_pair[0]-$pos_corr-4 : 0);
				while (substr ( $panel_PE_short_Plus[$i], $offset, -1 )  =~  /\S+/) {
					$i++ ;
					unless ( $panel_PE_short_Plus[$i] ) { $panel_PE_short_Plus[$i] = $empty }
				}
				substr ( $panel_PE_short_Plus[$i], $sh_pair[0]-$pos_corr, length($sh_pair[2]." ".$sh_pair[3]), $sh_pair[2]." ".$sh_pair[3] );  # Prepare print PE read
	
				# PE Statistics:
				my $panel_no_local = $panel_no;
				push (@PE_short_plus,$sh_pair[0]);
				if ( @PE_short_plus >= $PE_short_reads_in_dist ){
					$PE_span = $PE_short_plus[$PE_short_reads_in_dist-1] - $PE_short_plus[0];
					if ( $PE_span > $PE_short_max_dist ) {
						while ($PE_short_plus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_short_plus[0]-($panel_no_local*$panel_width))."     Low frequency of PE_short+:     ".sprintf("%10d",$PE_short_plus[0]).sprintf("%10d",$PE_short_plus[$PE_short_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_short_plus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_short_plus = (); # to avoid spamming the mutation report
					}
					shift @PE_short_plus;
				}
			}
	
			if ( $sh_pair[1] eq "- +" || $sh_pair[1] eq "- -" ) {
				$i = 0;
				unless ( $panel_PE_short_Minus[$i] ) { $panel_PE_short_Minus[$i] = $empty }
				$offset = ($sh_pair[0]-$pos_corr-4 > 0? $sh_pair[0]-$pos_corr-4 : 0);
				while (substr ( $panel_PE_short_Minus[$i], $offset, -1 )  =~  /\S+/) {
					$i++ ;
					unless ( $panel_PE_short_Minus[$i] ) { $panel_PE_short_Minus[$i] = $empty }
				}
				substr ( $panel_PE_short_Minus[$i], $sh_pair[0]-$pos_corr, length($sh_pair[2]." ".$sh_pair[3]), $sh_pair[2]." ".$sh_pair[3] );  # Prepare print PE read

				# PE Statistics:
				my $panel_no_local = $panel_no;
				push (@PE_short_minus,$sh_pair[0]);
				if ( @PE_short_minus >= $PE_short_reads_in_dist ){
					$PE_span = $PE_short_minus[$PE_short_reads_in_dist-1] - $PE_short_minus[0];
					if ( $PE_span > $PE_short_max_dist ) {
						while ($PE_short_minus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_short_minus[0]-($panel_no_local*$panel_width))."     Low frequency of PE_short-:     ".sprintf("%10d",$PE_short_minus[0]).sprintf("%10d",$PE_short_minus[$PE_short_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_short_minus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_short_minus = (); # to avoid spamming the mutation report
					}
					shift @PE_short_minus;
				}
			}	
			$sh_pair = shift @short_pair;
			@sh_pair = split "\t", $sh_pair ;
		} # End while ( 0 < $sh_pair[0] ...
	
		if ( $sh_pair[0] > ( $panel_no + 1 ) * $panel_width ) {
			push @short_pair, $sh_pair;
			$sh_pair = "";
			@sh_pair = "";	
		}	
		# End short_pair - start long_pair	
	
		@long_pair = sort {$a cmp $b} @long_pair;
		$lo_pair = shift @long_pair;
		@lo_pair = split "\t", $lo_pair ;	
		if ( $lo_pair[0] > ( $panel_no + 1 ) * $panel_width ) {
			push @long_pair, $lo_pair;
			$lo_pair = "";
			@lo_pair = "";
		}	
		while ( 0 < $lo_pair[0] && $lo_pair[0] <= ( $panel_no + 1 ) * $panel_width ) {	
			if ($lo_pair[1]  eq "+ -" || $lo_pair[1] eq "+ +" ) {
				$i = 0;
				unless ( $panel_PE_long_Plus[$i] ) { $panel_PE_long_Plus[$i] = $empty }
				$offset = ($lo_pair[0]-$pos_corr-4 > 0? $lo_pair[0]-$pos_corr-4 : 0);			
				while (substr ( $panel_PE_long_Plus[$i], $offset, -1 )  =~  /\S+/) {
					$i++ ;
					unless ( $panel_PE_long_Plus[$i] ) { $panel_PE_long_Plus[$i] = $empty }
				}
				substr ( $panel_PE_long_Plus[$i], $lo_pair[0]-$pos_corr, length($lo_pair[2]." ".$lo_pair[4]), $lo_pair[2]." ".$lo_pair[4] );  # Prepare print PE read
				# PE Statistics:
				my $panel_no_local = $panel_no;
				push (@PE_long_plus,$lo_pair[0]);
				if ( @PE_long_plus >= $PE_long_reads_in_dist ){
					$PE_span = $PE_long_plus[$PE_long_reads_in_dist-1] - $PE_long_plus[0];
					if ( $PE_span < $PE_long_min_dist ) {
						while ($PE_long_plus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_long_plus[0]-($panel_no_local*$panel_width))."     High frequency of PE_long+:     ".sprintf("%10d",$PE_long_plus[0]).sprintf("%10d",$PE_long_plus[$PE_long_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_long_plus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_long_plus = (); # to avoid spamming the mutation report
					}
					shift @PE_long_plus;
				}
			}   # END  if ($lo_pair[1]  eq "+ -"
			if ($lo_pair[1]  eq "- +" || $lo_pair[1] eq "- -" ) {
				$i = 0;
				unless ( $panel_PE_long_Minus[$i] ) { $panel_PE_long_Minus[$i] = $empty }
				$offset = ($lo_pair[0]-$pos_corr-4 > 0? $lo_pair[0]-$pos_corr-4 : 0);			
				while (substr ( $panel_PE_long_Minus[$i], $offset, -1 )  =~  /\S+/) {
					$i++ ;
					unless ( $panel_PE_long_Minus[$i] ) { $panel_PE_long_Minus[$i] = $empty }
				}
				substr ( $panel_PE_long_Minus[$i], $lo_pair[0]-$pos_corr, length($lo_pair[2]." ".$lo_pair[4]), $lo_pair[2]." ".$lo_pair[4] );  # Prepare print PE read
				# PE Statistics:
				my $panel_no_local = $panel_no;
				push (@PE_long_minus,$lo_pair[0]);
				if ( @PE_long_minus >= $PE_long_reads_in_dist ){
					$PE_span = $PE_long_minus[$PE_long_reads_in_dist-1] - $PE_long_minus[0];
					if ( $PE_span < $PE_long_min_dist ) {
						while ($PE_long_minus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_long_minus[0]-($panel_no_local*$panel_width))."     High frequency of PE_long-:     ".sprintf("%10d",$PE_long_minus[0]).sprintf("%10d",$PE_long_minus[$PE_long_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_long_minus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_long_minus = (); # to avoid spamming the mutation report
					}
					shift @PE_long_minus;
				}
			}	# END	if ($lo_pair[1]  eq "- +"
	
		$lo_pair = shift @long_pair;
		@lo_pair = split "\t", $lo_pair ;
		}  # END while ( 0 < $lo_pair[0]
	
		if ( $lo_pair[0] > ( $panel_no + 1 ) * $panel_width ) {
			push @long_pair, $lo_pair;
			$lo_pair = "";
			@lo_pair = "";
		}	
		# End long_pair - start unpair_pair
	
		@unpair_pair = sort {$a cmp $b} @unpair_pair;
		$un_pair = shift @unpair_pair;
		@un_pair = split "\t", $un_pair ;	
		if ( $un_pair[0] > ( $panel_no + 1 ) * $panel_width ) {
			push @unpair_pair, $un_pair;
			$un_pair = "";
			@un_pair = "";
		}	
		while ( 0 < $un_pair[0] && $un_pair[0] <= ( $panel_no + 1 ) * $panel_width ) {  # The building of this unpair loop deviates from the short&long loops by printing + & - in same
			$i = 0;                                                                           # lines but doing the statistics separately
			unless ( $panel_PE_unpair[$i] ) { $panel_PE_unpair[$i] = $empty }
			$offset = ($un_pair[0]-$pos_corr-4 > 0? $un_pair[0]-$pos_corr-4 : 0);					
			while (substr ( $panel_PE_unpair[$i] , $offset, -1 )  =~  /\S+/) {
				$i++ ;
				unless ( $panel_PE_unpair[$i] ) { $panel_PE_unpair[$i] = $empty }
			}
			chop $un_pair[2];
			substr ( $panel_PE_unpair[$i], $un_pair[0]-$pos_corr, length($un_pair[2]), $un_pair[2] );  # Prepare print PE read
			# PE Statistics:
			if ( $un_pair[2] =~ /PE\+/) {
				my $panel_no_local = $panel_no;
				push (@PE_unpair_plus,$un_pair[0]);
				if ( @PE_unpair_plus >= $PE_unpair_reads_in_dist ){
					$PE_span = $PE_unpair_plus[$PE_unpair_reads_in_dist-1] - $PE_unpair_plus[0];
					if ( $PE_span < $PE_unpair_min_dist ) {
						while ($PE_unpair_plus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_unpair_plus[0]-($panel_no_local*$panel_width))."     High frequency of PE_unpair+:   ".sprintf("%10d",$PE_unpair_plus[0]).sprintf("%10d",$PE_unpair_plus[$PE_unpair_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_unpair_plus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_unpair_plus = (); # to avoid spamming the mutation report
					}
					shift @PE_unpair_plus;
				}
			}
			if ( $un_pair[2] =~ /PE-/ ) {
				my $panel_no_local = $panel_no;
				push (@PE_unpair_minus,$un_pair[0]);
				if ( @PE_unpair_minus >= $PE_unpair_reads_in_dist ){
					$PE_span = $PE_unpair_minus[$PE_unpair_reads_in_dist-1] - $PE_unpair_minus[0];
					if ( $PE_span < $PE_unpair_min_dist ) {
						while ($PE_unpair_minus[0]-$panel_no_local*$panel_width < 0){$panel_no_local--}
						$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no_local."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no_local).$h_hr_e1;
						$PE_rep = sprintf('%8d',$PE_unpair_minus[0]-($panel_no_local*$panel_width))."     High frequency of PE_unpair-:   ".sprintf("%10d",$PE_unpair_minus[0]).sprintf("%10d",$PE_unpair_minus[$PE_unpair_reads_in_dist-1]).sprintf("%10d",$PE_span);
						$x = substr ($Repeat_total, $PE_unpair_minus[0], $PE_span);
						$y = ($x =~ /\+/? "x": "o");
						print PE_Report "$h_link $PE_rep   $y$x;\n";
						@PE_unpair_minus = (); # to avoid spamming the mutation report
					}
					shift @PE_unpair_minus;
				}
			}	
		$un_pair = shift @unpair_pair;
		@un_pair = split "\t", $un_pair ;
		}# End 	while ( 0 < $un_pair[0]
	
		if ( $un_pair[0] > ( $panel_no + 1 ) * $panel_width ) {
			push @unpair_pair, $un_pair;
			$un_pair = "";
			@un_pair = "";
		}	
	} # End 	if ($PE_reads)

	# Build GenBank based annotations
	while ( 0 <= $anno[0][0] && $anno[0][0]  <= ( $panel_no + 1 ) * $panel_width  ) {
		if ( $Anno_no >= $info_lineno-1 ) { $Anno_no = 0 }
		if ( $anno[0][3] =~ /RNA/ ) { $anno[0][7] = "r" x ($anno[0][1]-$anno[0][0])  }
		unless (substr ( $AnnoPrint[0] , $anno[0][0]-$pos_corr, $panel_width ) =~ /(\S+)/ ) {			$Anno_no = 0;		}  #Parenthesis to avoid auto replace
		if ( substr ( $AnnoPrint[$Anno_no], $anno[0][0]-$pos_corr, $panel_width ) =~ /(\S+)/)  {$Anno_no += 2}   # Avoid overprinting #Parenthesis to avoid auto replace
		substr ( $AnnoPrint[$Anno_no] , $anno[0][0]-$pos_corr, 0, $anno[0][7] );  # Prepare Annotation sequence
		$Anno_no++;
		$ap = join ( " ", $anno[0][4],$anno[0][5],$anno[0][6] );
		$l_ap = length $ap;
		substr ( $AnnoPrint[$Anno_no] , $anno[0][0]-$pos_corr, $l_ap, $ap );  # Prepare Annotation information
		$anno_panel_no = $panel_no + 1;
		while ($anno[0][1] > $anno_panel_no*$panel_width) {
			$AnnoPrint[$Anno_no] .= $empty;
			substr ( $AnnoPrint[$Anno_no] , $anno_panel_no*$panel_width-$pos_corr, $l_ap, $ap ); 
			$anno_panel_no++;			
		}
		$anno_pos = $anno[0][4]." (".$anno[0][6].")";   # Save annotation for each position
		$anno_panel = ( $anno_panel? $anno_panel."; ".$anno[0][4]: $anno[0][4] );
		$next = 0;
		while ($anno[0][1]-$pos_corr > $panel_width*($next+1)) {
			$anno_panel_next[$next] = ($anno_panel_next[$next]? $anno_panel_next[$next]."; ".$anno[0][4]:$anno[0][4] );
			$next++;
		}
		for $i ( $anno[0][0]-$pos_corr ..$anno[0][1]-$pos_corr  ) {
			$anno_pos[$i] = ($anno_pos[$i]? join "\t",$anno_pos[$i],$anno_pos : $anno_pos  ) ;
		}
		shift @anno;
		$Anno_no++;
	}
	
	if ($snp_bed) {
		while ( $SNP_bed[0][1] <= ( $panel_no + 1 ) * $panel_width  ) {
			my $SNP_start = $SNP_bed[0][1] - $panel_no * $panel_width + 1;
			my $SNP_length = $SNP_bed[0][2] - $SNP_bed[0][1] ;
			my $SNP_replace = $SNP_bed[0][6];
			unless ( substr ( $StrAlSNP_bed[0] , $SNP_start -6, 6 + length $SNP_replace ) =~  /\S+/ ) { $i = 0 }
			substr ( $StrAlSNP_bed[$i] , $SNP_start, length $SNP_replace, $SNP_replace );
			$SNP_panel_replace = "s" x $SNP_length;
			substr ( $StrAlSNP_bed_panel, $SNP_start, $SNP_length, $SNP_panel_replace );
			shift @SNP_bed;
			$i++;
		}
	}

# make sequence ruler
	$seqruler = $empty;
	$panelstart = ($panel_width * $panel_no);  # deleted 1 + to become = 0-based
	my $x = $LSP . " ";
	substr ( $x, -length $panelstart, length $panelstart, $panelstart);
	substr ( $seqruler, 0, length $x, $x);
	#make dots
	for ($i = 1; $i < $panel_width / 10; $i++){ substr ( $seqruler, length ($LSP) + 10*$i , 1, ".");  }
	for ($i = 1; $i < $panel_width / 100; $i++){ substr ( $seqruler, length ($LSP) + 100*$i + 1 - length($i), length($i), $i);  }
	# seq ruler change
	my $y = $panelstart + $panel_width - 1;   # Perhaps delete  - 1 to become = 0-based
	my $pw = $panel_width;
	if ($y > $reg_end) {
		$y = $reg_end;
		$pw = 1 + $reg_end - $panel_no*$panel_width;
	}
	substr ( $seqruler, length ($x) + $pw - length ($y) -1, $panel_width, $y);
	$anchor = " "x 50;
	for ($i = 1; $i < 5 + $panel_width / 10; $i++){
		$anchor .= '<a id="a'.$i.'" name="a'.$i.'"></a>'.'          ';
	}

#save prev seqpr and prepare sequence for print
	$seqpr_prev = ($seqpr? substr $seqpr, -2: "  ");  # used for translation
	if (length $seq >= $panel_width ) {
		$seqpr = substr $seq, 0 , $panel_width, "";
		$seqpr_next = substr $seq, 0, 2;  # used for translation
	}
	else {
		$seqpr = substr $seq, 0 , length $seq, ""
	}
	$seqpr_c = Comp($seqpr);

# Calculate everything
	@match_p_density_panel = splice (@match_p_density,0,$panel_width);
	push(@match_p_density,@empty_pv);

	@match_m_density_panel = splice (@match_m_density,0,$panel_width);
	push(@match_m_density,@empty_pv);

	@match_mut_density_panel = splice (@match_mut_density,0,$panel_width);
	push(@match_mut_density,@empty_pv);

	@match_mut_p_density_panel = splice (@match_mut_p_density,0,$panel_width);
	push(@match_mut_p_density,@empty_pv);

	@match_mut_m_density_panel = splice (@match_mut_m_density,0,$panel_width);
	push(@match_mut_m_density,@empty_pv);

	@match_indel_density_panel = splice (@match_indel_density,0,$panel_width);
	push(@match_indel_density,@empty_pv);
	
	@match_indel_p_density_panel = splice (@match_indel_p_density,0,$panel_width);
	push(@match_indel_p_density,@empty_pv);

	@match_indel_m_density_panel = splice (@match_indel_m_density,0,$panel_width);
	push(@match_indel_m_density,@empty_pv);
	$StrAlRepeat_panel = substr ($Repeat_total, $pos_corr, $panel_width);
	@SeqQual = @StrAlRepeat_panel = split "", $StrAlRepeat_panel;  

	# All position specific calculations in each panel are in this section:
	for ( $i = 0; $i < $panel_width; $i++ ) {
		
		# Estimate of continuity of quality scores for InDel reads
		if ( $point_count[$i] >= $ind_min ) {
			$ID_qual = "";
			$rdq_left = $rdq_left_no = $rdq_right = $rdq_right_no = 0.001;			
			for $j (0..$point_count[$i]-1) {
				my @rd_qual_rep = split "\t", $ID_qual[$i][$j];
				my @rd_qual = split "", $rd_qual_rep[2];
				my $cut = $i-$rd_qual_rep[0];				
				for $k ($cut-4..$cut-1) {
					if (ord $rd_qual[$k]>$qbase) {
						$rdq_left += ord $rd_qual[$k];
						$rdq_left_no++;
					}
				}
				 for $k ($cut..$cut+3) {
					if (ord $rd_qual[$k]>$qbase) {
						$rdq_right += ord $rd_qual[$k];
						$rdq_right_no++;
					}
				}
				$qual_left  = ($rdq_left  / $rdq_left_no)  - $qbase + 0.001;
				$qual_right = ($rdq_right / $rdq_right_no) - $qbase + 0.001;
			}		
			#	$ID_qual = abs ($qual_left / $qual_right);
			$ID_qual = $qual_left / $qual_right;
		}  # End if ( $point_count[$i] >= $ind_min ) 
		
		my $b_pos = $panel_no * $panel_width + $i;
		$SQ = "n";

		if ($match_p_density_panel[$i] > 0 && $match_m_density_panel[$i] > 0) {$SQ = "C"}
		else { if ($match_p_density_panel[$i] > 0 || $match_m_density_panel[$i] > 0){$SQ = "c"} }
		unless ( $StrAlRepeat_panel[$i] eq " " ) {$SQ = "R"; $read_panel[1] = 1; $read_panel[2] = "R"}

		# report mutations if: 
		# 1) at least $mut_min mut reads &&
		# 2) # of mut reads > $mut_freq_min * (plus + minus matching reads)
		$limit = ( $match_p_density_panel[$i] +  $match_m_density_panel[$i] ) * $mut_freq_min;
		if ( $match_mut_density_panel[$i] >= $mut_min ) {
			if  ( $match_mut_density_panel[$i] >= $limit  ) {
				%freq = ();                                   # Calculate the most frequent mutant nucleotide.
				$MutNuc = "";
				$mutation = sprintf("%10s","?" );
				@freq_nuc = split "", $MutSeq[$i];	 
				for $i (0 .. @freq_nuc-1) {	$freq{$freq_nuc[$i]} += 1 / @freq_nuc}
				foreach $nuc (a,c,g,t) { 
					if ($freq{$nuc} > 0.5 ) {
						$MutNuc = $nuc;
						$MutNut_freq = sprintf("%.2f",$freq{$nuc});
						$mutation = sprintf("%10s",substr ($seqpr, $i , 1).">$MutNuc ($MutNut_freq)") ;
					}
				}
				$aa_mutation = $an_aa = "";
				if ($MutNuc) {
					for $j ( 0 .. $info_lineno ) {            # Changed aa?  Frame and position in triplet
						$AnnoPrint_mut[$j] = $AnnoPrint_prev[$j].$AnnoPrint[$j];
						$AP_sub = substr $AnnoPrint_mut[$j], $i, 5; 
						$mutant_seqpr   = $seqpr_prev.$seqpr.$seqpr_next;
						
						$x_tst1 = $mutant_seqpr ;
						
						substr ( $mutant_seqpr, $i+2, 1, $MutNuc) ; # save and mutate $seqpr
						
						if ( $AP_sub =~ /\,(\w)\./g) {			# forward direction
							$translate_pos = pos($AP_sub)-3+$i;
							$translate_seq1 = substr ( $seqpr_prev.$seqpr, $translate_pos, 3 ) ;
							$translate_seq2 = substr ( $mutant_seqpr, $translate_pos, 3 ) ;
							$translate_aa  = translate ($translate_seq2);
							$an_aa = $1;								
							$aa_mutation .= "$an_aa>$translate_aa; ";
						}		
						if ( $AP_sub =~ /\.(\w)\,/g) {			# reverse direction
							$translate_pos = pos($AP_sub)-3+$i;
							$translate_seq1 = substr ( $seqpr_prev.$seqpr, $translate_pos, 3 ) ;
							$translate_seq2 = substr ( $mutant_seqpr, $translate_pos, 3 ) ;
							$translate_aa  = translate ( revComp ($translate_seq2));
							$an_aa = $1;							
							$aa_mutation .= "$an_aa>$translate_aa; ";
						}	
					}  # END for $j..
				} # END 	if ($MutNuc) {
			
				$aa_mutation	= sprintf("%15s",	$aa_mutation )  ;            
				my $an = int($i/10) ;
				$anchor_link = "#a".$an;
				$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no."_Report.htm".$anchor_link.$h_tb_s9.sprintf("%8s", $panel_no).$h_hr_e1;				
				$mut_rep = sprintf("%7d",$i)."   Mutation: ".sprintf("%8d",$match_mut_density_panel[$i]).sprintf("%7d",$match_mut_p_density_panel[$i]).sprintf("%7d",$match_mut_m_density_panel[$i]).sprintf("%7d", $match_p_density_panel[$i]+$match_m_density_panel[$i])."        ".sprintf("%8s",$StrAlRepeat_panel[$i]).sprintf("%8s",substr ($StrAlSNP_bed_panel, $i, 1)).$mutation.$aa_mutation." ".$anno_pos[$i];				
				unless ($no_mut_in_repeats && ($StrAlRepeat_panel[$i] eq "+") ) {
					print MUT_Report_html "$h_link$mut_rep\n";
				}
				my $x = sprintf("%8d",$panel_no);
				$SQ = "M";
			} # End if ( $match_mut_density_panel[$i] >= $mut_min )
		}
			
		# report indels if: 
		# 1) at least $ind_min indel reads at same position && 
		# 2) # of indel reads > $mut_freq_min * plus + minus matching reads &&
		# 3) InDel Quality is within 1+/- $ID_limit
		if ( $match_indel_density_panel[$i] >= $ind_min) {
			if  ( $match_indel_density_panel[$i] >= $limit  ) {
				if ( abs (1-$ID_qual) < $ID_limit) {
					my $an = int($i/10) ;
					$anchor_link = "#a".$an;
					$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no."_Report.htm".$anchor_link.$h_tb_s9.sprintf("%8s", $panel_no).$h_hr_e1;
					$mut_rep = sprintf("%7d",$i)."   InDel:    ".sprintf("%8d",$match_indel_density_panel[$i]).sprintf("%7d",$match_indel_p_density_panel[$i]).sprintf("%7d",$match_indel_m_density_panel[$i]).sprintf("%7d", $match_p_density_panel[$i]+$match_m_density_panel[$i]).sprintf("%8.2f",$ID_qual).sprintf("%8s",$StrAlRepeat_panel[$i]).sprintf("%8s",substr ($StrAlSNP_bed_panel, $i, 1))."                          ".$anno_pos[$i];	
					unless ($no_mut_in_repeats && ($StrAlRepeat_panel[$i] eq "+") ) {
						print MUT_Report_html "$h_link$mut_rep\n";
					}	
					$SQ = "I";
				}
			}
		}

		# build Quality - confirmed bases - report unconfirmed bases
		if ($SQ eq "n") {
			$SQ_n++; 
			$nc_length++; 
			unless ($nc_nucl) {
				$nc_nucl = "y"; 
				$nc_pos = "  StartPos:\t".sprintf("%9d", $b_pos);
				$nc_pos_html = sprintf("%12d", $b_pos);
			} 
		}
		if ($SQ ne "n" && $nc_nucl eq "y") {
			$nc_pos = $nc_pos."\tLastPos:\t".sprintf("%9d", $b_pos)."\tLength:\t".sprintf("%9d", $nc_length)."\t\n";
			$nc_pos_html = $nc_pos_html.sprintf("%12d", $b_pos).sprintf("%9d", $nc_length);
			$nc_nucl = $nc_length = ""; 
			push @nt_undef, $nc_pos;
			my $an = int($i/10) ;
			$anchor_link = "#a".$an;
			$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no."_Report.htm".$anchor_link.$h_tb_s9.sprintf("%8s", $panel_no).$h_hr_e1;
			$unconf_html = sprintf("%8d",$i)."    Unconfirmed:	$nc_pos_html	$anno_pos[$i]";
			print UNC_Report_html "$h_link$unconf_html\n";			
		}		
		if ($SQ eq "c") {$SQ_c++}
		if ($SQ eq "C") {$SQ_C++}
		if ($SQ eq "M") {$SQ_M++}
		if ($SQ eq "I") {$SQ_I++}
		if ($SQ eq "R") {$SQ_R++}
		$SeqQual[$i]=$SQ;	
	}		#end 	for ( $i = 0; $i < $panel_width; $i++ )
			 
	$SeqQual = join "", @SeqQual;
		
	#Gamma-analysis:
	for $i (0 .. $panel_width-$rd_length_max) {
		unless ( substr ($SeqQual, $i, $rd_length_max) =~ /[^ncC]+/  ) {				
			$p_start = $start_p_density[$i];
			$m_start = $start_m_density[$i];
			$gamma_p_start[$p_start]++;
			$gamma_m_start[$m_start]++;				
			$p_dens = $match_p_density_panel[$i];
			$m_dens = $match_m_density_panel[$i];
			$gamma_p_dens[$p_dens]++;
			$gamma_m_dens[$m_dens]++;
		}
	}
	@start_p_density = @start_m_density = ();
	
	# Annotaions; SNP's and Mutations + InDel's:
	if ($anno) {
		for $i ( 0 .. $info_lineno ) {			
			$AnnoPrint_prev[$i] = substr ( $AnnoPrint[$i], $panel_width-2, 2 );	# Save previous AnnoPrint:			
			$a_p[$i] = substr $AnnoPrint[$i], 0, $panel_width, "" ;
			$AnnoPrint[$i] =~ s/\s+$//;
			$AnnoPrint[$i] = $AnnoPrint[$i].$empty;
			if ( $a_p[$i] =~  /\S+/) {
				push @Anno_html, $a_p[$i];
			}
		}
	}
	# report if anno-bed annotated proteins does not fit to DNA sequence, initally meant to check UCSC browser derived annotations
	if ($check_translation && $anno ) { Check_translation_print () }  
	@a_p = "";

	if ($snp_bed) {
		for $i ( 0 .. $info_lineno ) {
			$StrAlSNP_bed_panel[$i] = substr $StrAlSNP_bed[$i], 0, $panel_width, "" ;
			$StrAlSNP_bed[$i] = $StrAlSNP_bed[$i].$empty;
		}
	}

	###   print html section:
	#############################

	$z = ">./html/".$fid_core."panel_".$panel_no."_Report.htm";
	open (P_Report_html, "$z");

	$h_link_p = $h_hr_s1.$fid_core."panel_".($panel_no-1)."_Report.htm".$h_hr_s8."panel: ".($panel_no-1).$h_hr_e1;
	if ($panel_no == $panel_no_start) {$h_link_p = $h_hr_s1.$fid_core."panel_".($nop)."_Report.htm".$h_hr_s8."panel: ".($nop).$h_hr_e1}
	
	$h_link_n = $h_hr_s1.$fid_core."panel_".($panel_no+1)."_Report.htm".$h_hr_s8."panel: ".($panel_no+1).$h_hr_e1;
	if ($panel_no == $nop) {$h_link_n = $h_hr_s1.$fid_core."panel_".($panel_no_start)."_Report.htm".$h_hr_s8."panel: ".($panel_no_start).$h_hr_e1;}
	
	print P_Report_html "<pre>panel: $panel_no	Matching reads file: $match    on: $date: $tid
	Previous $h_link_p    Next $h_link_n 		\n";

	$h_link = "panel: ".$h_hr_s2.$fid_core."panel_".$panel_no."_Report.htm".$h_tb_s9.sprintf("%8s", $panel_no).$h_hr_e1;
	$region = "; bases". sprintf("%11s", $reg_start)." to". sprintf("%11s", $reg_end);
	print I_Report_html "$h_link$region      $anno_panel\t\n";
	$anno_panel = $anno_panel_next[0];
	shift @anno_panel_next;

	#Reads
	if ($print_reads ) {
		@StrAlPlus = reverse @StrAlPlus;    @StrAlMinus = reverse @StrAlMinus;  # Invert arrays for print
		for $i ( 0 .. @StrAlPlus-1 ) { if ( $StrAlPlus[$i]=~  /\S+/) { $x = substr $StrAlPlus[$i], 0, $panel_width ; print P_Report_html "$HTML_P_rds$x\n"; }  }
		print P_Report_html "Anchor $anchor P<br>";
		for $i ( 0 .. @StrAlMinus-1 ) { if ( $StrAlMinus[$i]=~  /\S+/) { $x = substr $StrAlMinus[$i], 0, $panel_width ; print P_Report_html "$HTML_M_rds$x\n"; }  }
		@StrAlPlus = reverse @StrAlPlus;    @StrAlMinus = reverse @StrAlMinus;  # Invert arrays back again
	}
	if ($print_read_density) {
		# print + read density;
		print_read_density(@match_p_density_panel);
		$match_p_density_print = $density;
		print P_Report_html "$HTML_P_rds_sum$match_p_density_print $LSP\n";

		# print - read density;
		print_read_density(@match_m_density_panel);
		$match_m_density_print = $density;
		print P_Report_html "$HTML_M_rds_sum$match_m_density_print $LSP\n";
	}	# if ($print_read_density)

	# Repeat, Ruler, Quality,
	print P_Report_html "$HTML_Repeat$StrAlRepeat_panel$LSP\n";
	print P_Report_html "$seqruler\n$LSP$seqpr\n$LSP$seqpr_c$LSP\n";
	print P_Report_html "\n$HTML_Cover$SeqQual$LSP\n";

	# Annotaions; SNP's and Mutations + InDel's:

	if (@Anno_html) {
		for $i ( 0 .. @Anno_html ) {
			if ( $Anno_html[$i] =~  /\S+/) {
				print P_Report_html "$HTML_Anno$Anno_html[$i]\n";
			}
		}
		@Anno_html=();
	}

	if ($snp_bed) {
		for $i ( 0 .. $info_lineno ) {
			if ( $StrAlSNP_bed_panel[$i] =~  /\S+/) {
				print P_Report_html "$HTML_SNP$StrAlSNP_bed_panel[$i]\n";
			}
		}
	}

	print P_Report_html "\n";
	
	for $i ( 0 .. @panelStrAlMutPlus ) {
		if ( $panelStrAlMutPlus[$i]  =~ /\S+/) {
			@mut_pos_line = reverse ( split ("\t", $mut_pos_p[$i]) );
			foreach $mpl (@mut_pos_line) {
				@mpl = split (" ", $mpl);
				if ($mpl[1] && $mpl[1] <= $panel_width){   # '$mpl[0] && '  deleted
					substr ( $panelStrAlMutPlus[$i], $mpl[1], 0, $bold_ );
					substr ( $panelStrAlMutPlus[$i], $mpl[0], 0, $bold );
				}					
				elsif ($mpl[0] && $mpl[1] && $mpl[0]< $panel_width&& $mpl[1] > $panel_width){
					substr ( $panelStrAlMutPlus[$i], $panel_width, 0, $bold_ );
					substr ( $panelStrAlMutPlus[$i], $mpl[0], 0, $bold );
					$mpl_next[0] = 0;
					$mpl_next[1] = $mpl[1] - $panel_width;
					$mpl_next = join (" ", @mpl_next);
					unshift (@mut_pos_line_next,$mpl_next);  						
				}		
				elsif ($mpl[0] && $mpl[1] && $mpl[0] >= $panel_width){
					$mpl_next[0] = $mpl[0] - $panel_width;
					$mpl_next[1] = $mpl[1] - $panel_width;
					$mpl_next = join (" ", @mpl_next);
					unshift (@mut_pos_line_next,$mpl_next);   
				}
			}
			
			$mut_pos_p_next[$i] = join "\t", @mut_pos_line_next;
			@mut_pos_line_next = ();
			print P_Report_html "$HTML_P_MMrds$panelStrAlMutPlus[$i]\n";  #You should Build in a truncation of @ here
		}
	}
	@panelStrAlMutPlus = ();
	@mut_pos_line = ();   
	@mut_pos_p = @mut_pos_p_next;
	@mut_pos_p_next = ();
	
	print P_Report_html "$hr";		
	for $i ( 0 .. @panelStrAlMutMinus ) {
		if ( $panelStrAlMutMinus[$i] =~  /\S+/) {
			@mut_pos_line = reverse ( split ("\t", $mut_pos_m[$i]) );				
			foreach $mpl (@mut_pos_line) {
				@mpl = split (" ", $mpl);
				if ($mpl[1] && $mpl[1]<= $panel_width){   # '$mpl[0] && '  deleted
					substr ( $panelStrAlMutMinus[$i], $mpl[1], 0, $bold_ );
					substr ( $panelStrAlMutMinus[$i], $mpl[0], 0, $bold );
				}
				elsif ($mpl[0] && $mpl[1] && $mpl[0]< $panel_width&& $mpl[1] > $panel_width){
					substr ( $panelStrAlMutMinus[$i], $panel_width, 0, $bold_ );
					substr ( $panelStrAlMutMinus[$i], $mpl[0], 0, $bold );
					$mpl_next[0] = 0;
					$mpl_next[1] = $mpl[1] - $panel_width;
					$mpl_next = join (" ", @mpl_next);
					unshift (@mut_pos_line_next,$mpl_next);  						
				}	
				elsif ($mpl[0] && $mpl[1] && $mpl[0] >= $panel_width){
					$mpl_next[0] = $mpl[0] - $panel_width;
					$mpl_next[1] = $mpl[1] - $panel_width;
					$mpl_next = join (" ", @mpl_next);
					unshift (@mut_pos_line_next,$mpl_next);   # Complicated sorting ?Necessary?
				}
			}
			
			$mut_pos_m_next[$i] = join "\t", @mut_pos_line_next;
			@mut_pos_line_next = ();
			print P_Report_html "$HTML_M_MMrds$panelStrAlMutMinus[$i]\n";  # Should Build in a truncation of @ here

		} # End if ( $panelStrAlMutMinus[$i] 
	}
	@panelStrAlMutMinus = ();
	@mut_pos_line = ();   
	@mut_pos_m = @mut_pos_m_next;
	@mut_pos_m_next = ();
	
	print P_Report_html "$seqruler\n";		
	# Print mut and indel reads:
	if ($print_read_density) {
		print_read_density(@match_mut_density_panel);
		$match_mut_density_print = $density;
		print P_Report_html "$LSP$match_mut_density_print $LSP\n";
		print_read_density(@match_indel_density_panel);
		$match_indel_density_print = $density;
		print P_Report_html "$LSP$match_indel_density_print $LSP\n";
	} # end  Print mut and indel reads:
	print P_Report_html "$LSP$seqpr\n";

	if ($PE_reads) {
		for $i ( 0 .. @panel_PE_short_Plus ) {
			if ( $panel_PE_short_Plus[$i] =~  /\S+/) {
				print P_Report_html "$HTML_PESp$panel_PE_short_Plus[$i]\n";
			}
		}
		for $i ( 0 .. @panel_PE_short_Minus ) {
			if ( $panel_PE_short_Minus[$i] =~  /\S+/) {
				print P_Report_html "$HTML_PESm$panel_PE_short_Minus[$i]\n";
			}
		}
		print P_Report_html "$hr";
		for $i ( 0 .. @panel_PE_long_Plus ) {
			if ( $panel_PE_long_Plus[$i] =~  /\S+/) {
				print P_Report_html "$HTML_PELp$panel_PE_long_Plus[$i]\n";
			}
		}
		for $i ( 0 .. @panel_PE_long_Minus ) {
			if ( $panel_PE_long_Minus[$i] =~  /\S+/) {
				print P_Report_html "$HTML_PELm$panel_PE_long_Minus[$i]\n";
			}
		}
		print P_Report_html "$hr";
		for $i ( 0 .. @panel_PE_unpair ) {
			if ( $panel_PE_unpair[$i] =~  /\S+/) {
				print P_Report_html "$HTML_PEU$panel_PE_unpair[$i]\n";
			}
		}
	print P_Report_html "$seqruler\n";
	print P_Report_html "$LSP$seqpr\n\n";
	}	# END if ($PE_reads) 


	#### prepare for next panel:
	############################

	print Read_Report "$panel_no\t$read_panel[0]\t$read_panel[1]\t$read_panel[2]\n" ;
	@read_panel = ();

	tid();
	$pn = sprintf("%6d", $panel_no );
	if ( $panel_no % 500 == 0 ) {tid();print "$tid   $pn panels have been printed\n"}  # modulus
	$panel_no++;
	if ( !$EndOfMatch) {	$read_match = read_match(0) }
	if ( !$EndOfMut) {	$read_mut = read_mut(0) }
	if ( !$EndOfSeq) {	
		if ( length $seq <= $panel_width) { 
			$read_seq = read_seq (0) 
		} 
	}
	if ($PE_reads) {		PE_read ()	}			

	read_anno (0);
	
	# Truncate Arrays and add $empty

	for $i (0..$rd_length_max-1) {
		my $x = $i+$panel_width;
		for $j(0..$point_count[$x]-1) {
			my @idq = split "\t", $ID_qual[$x][$j];
			$idq[0] = $idq[0]-$panel_width;
			$idq[1] = $idq[1]-$panel_width;
			$ID_qual[$i][$j] = join "\t", @idq;
		}
	}	
	for $i ($rd_length_max..$panel_width+$rd_length_max) {
		for $j(0..$point_count[$i]-1) {
			$ID_qual[$i][$j] = "";
		}
	}
	splice (@point_count,0,$panel_width);
	splice (@anno_pos,0,$panel_width);
		
	# this way ensures that strings do not not increase in length  
	for ($i = 0; $i < @StrAlPlus; $i++){ if ( length $StrAlPlus[$i] >= $panel_width ) { $StrAlPlus[$i] = substr ( $StrAlPlus[$i], $panel_width, 2*$rd_length_max ) . $empty }	}
	for ($i = 0; $i < @StrAlMinus; $i++){ if ( length $StrAlMinus[$i] >= $panel_width ) { $StrAlMinus[$i] = substr ( $StrAlMinus[$i], $panel_width, 2*$rd_length_max ) . $empty }	}
	for ($i = 0; $i < @StrAlMutPlus; $i++){ if ( length $StrAlMutPlus[$i] >= $panel_width ) { $StrAlMutPlus[$i] = substr ( $StrAlMutPlus[$i], $panel_width, 2*$rd_length_max ) . $empty   }	}
	for ($i = 0; $i < @StrAlMutMinus; $i++){ if ( length $StrAlMutMinus[$i] >= $panel_width ) { $StrAlMutMinus[$i] = substr ( $StrAlMutMinus[$i], $panel_width, 2*$rd_length_max ) . $empty   }	}
	
	$StrAlSNP_bed_panel  = substr ( $StrAlSNP_bed_panel, $panel_width, $rd_length_max ) . $empty;   # SNP

	if ($PE_reads) {
		@panel_PE_short_Plus = ();	@panel_PE_short_Minus = ();
		@panel_PE_long_Plus = ();		@panel_PE_long_Minus = ();
		@panel_PE_unpair = ();
	}

} #end while $seq > 10 # Main loop

	tid();
	$pn = sprintf("%6d", $panel_no );
	print "$tid   $pn panels have been printed\n";
	
# Report stuff
	#Gamma-statistics:
	$x1 = @gamma_p_start;
	$x2 = @gamma_m_start;
	$x3 = @gamma_p_dens;
	$x4 = @gamma_m_dens;
	$gamma_max = max ($x1, $x2, $x3, $x4 ); 
	for $i (0 .. $gamma_max-1) {
		$gamma[$i] = join "\t" , sprintf("%4d", $i), sprintf("%8d", $gamma_p_start[$i]), sprintf("%8d", $gamma_m_start[$i]), sprintf("%8d", $gamma_p_dens[$i]), sprintf("%8d", $gamma_m_dens[$i]), sprintf("%8d", $gamma_p_start[$i]+$gamma_m_start[$i]), sprintf("%8d", $gamma_p_dens[$i]+$gamma_m_dens[$i]), "\n";
	}
	
tid();
$time_finish = $tid;
Date();
$SQ_C = sprintf("%9d", $SQ_C);
$SQ_c = sprintf("%9d", $SQ_c);
$SQ_n = sprintf("%9d", $SQ_n);
$SQ_R = sprintf("%9d", $SQ_R);
$SQ_I = sprintf("%9d", $SQ_I);
$SQ_M = sprintf("%9d", $SQ_M);
$panel_no_1 = $panel_no-1;
print AUX_Report "
The matching reads in: $match and funny reads in $mut was analyzed on the
$fa sequence and the annotations in $anno
Parameters from Eval_Reads.ini:
       
Chromosome size:                                 $chr_size     
Start number:                                    $start_no          
Maximal Read Length:                             $rd_length_max          

Print matching reads:                            $print_reads        
Print density of reads:                          $print_read_density 
Print mut qual strings:                          $print_mut_quality  

Max lines for annot's and SNP's:                 $info_lineno   		 
First panel number:                              $panel_no_start      
Last panel number:                               $panel_no_1            
Total number of panels:                          $panel_no     
Width of each panel:                              $panel_width   	     
Min overlap:                                     $seq_overlap        
Min distance between matching reads:             $min_pr    	  	   
Min InDel to report:                             $ind_min            
Min mut to report:                               $mut_min            
Min mut freq:                                    $mut_freq_min       
Verify translation of annotated proteins:        $check_translation  


$SQ_C\t bases were confirmed
$SQ_c\t bases were confirmed on one strand only
$SQ_n\t bases were NOT confirmed
$SQ_R\t bases were in repeats
$SQ_M\t putative mutations were found
$SQ_I\t putative InDel's were found

Analysis started at:   $time_start
and finished at:       $time_finish on $date\n
Unconfirmed nucleotides: \n @nt_undef

Gamma-statistics:
 @gamma

All parameters:
 @Eval_Reads
";



####################
# SUB ROUTINES #####
####################


sub find_chr_size
{
	my $CS=0;
	while (<Seq>) {
		s/\s//;
		if ($_ =~/^([acgtnmwrsyk]+)/i) {
			$CS = $CS + length $1; 
			} 
		}		
	return($CS);
} # End sub ChrSize

sub read_seq
{
	my $r=$_[0];
	while (<Seq>) {
		s/\s//;
		if ($_ =~/^([acgtnmwrsyk]+)/i) {$seq = $seq . $1;}
		if ( $r > 100 ) { return() ;  }
		$r++;
	}
	$EndOfSeq = 1;
	return(EndOfSeq) # end of file?
} #end sub read_seq

sub read_match
{
	if ($read_match) {return(EOM)};
	my $r=0; #local counter
	while (<Match>) {
		$r++;
		@match_read = split ('\t', $_);
		push (@match, [ @match_read ] );
		if ($PE_reads) { 
			$mr8 = $match_read[8];
			push @to_PE_read, $mr8;
			}
		if ( $match_read[0] > ( $panel_no + 1 ) * $panel_width  ) {
			$read_panel[0] += $r;
			return();
		}
	}
	# This fix returns a large value, that will stop the match read loop
	$match_read[0] = $start_no + $panel_width + $chr_size ;
	push (@match, [ @match_read ] );
	$EndOfMatch = 1;		
	$read_panel[0] += $r;
	return() # end of file?
} #end sub read_match

sub read_mut
{
	if ($read_mut) {return(EOM)};
	my $s=0; #local counter, needed?
	while (<Mut>) {
		$s++;
		s/z/ /g;     # rev 04a;
		s/~/ /g;     # rev 05-g;
		@mut_read = split ('\t', $_);
		push (@mut, [ @mut_read ] );		
		if ($PE_reads) {
			$mr8 = $mut_read[8]; 
			push @to_PE_read, $mr8;
		}
		if ( $mut_read[0] > ( $panel_no + 1 ) * $panel_width  ) {
			$read_panel[0] += $s;		# Include mut reads in read statistics		
			return()
		}
	}
	# This fix returns a large value, that will stop the mut read loop
	$mut_read[0] = $start_no + $panel_width + $chr_size ;
	push (@mut, [ @mut_read ] );
	$EndOfMut = 1;
	$read_panel[0] += $s;		# Include mut reads in read statistics
	return(EndOfMut) # end of file?
} #end sub read_mut

sub PE_read
{ 
	@to_PE_read = sort {$a cmp $b} (@to_PE_read);	
	while (@to_PE_read) {
		my @PE_in = split " ", shift @to_PE_read;
		my @pe_ret = ();
		$pe_ret[0] = $PE_in[1];
		$pe_ret[1] = "$PE_in[2] $PE_in[8]";
		$pe_ret[2] = "PE$PE_in[2]$PE_in[8]";
		$pe_ret[3] = $PE_in[5];	
		$pe_ret = join "\t",@pe_ret;	
		$dist_dev_a_b = abs( abs($PE_in[1] - $PE_in[7]) - $PE_dist );
		$sh_dist = ( ($pe_ret[1] eq "+ -" || $pe_ret[1] eq "- +") && $dist_dev_a_b < 4*$PE_dist_var);	
		if  ($sh_dist) {
			push (@short_pair, $pe_ret ) ;
		}
		elsif ($PE_in[6]) {
			$pe_ret[4] = $PE_in[6]." ".$PE_in[7] ;
			$pe_ret = join "\t",@pe_ret;
			push (@long_pair, $pe_ret ) ;
		}
		else {
			push (@unpair_pair, $pe_ret ) ;
		}
	}	
	@short_pair  = sort {$a cmp $b} (@short_pair);	
	@long_pair   = sort {$a cmp $b} (@long_pair);	
	@unpair_pair = sort {$a cmp $b} (@unpair_pair);	
	
	$pn = sprintf("%06s", $panel_no );
	$z = ">./test/A_PE".$fid_core."_".$pn."_PE.txt";
	open (PE_out, "$z");
	print PE_out "panel: $panel_no; Short reads:\n";
	for $i (0..@short_pair) { 		print PE_out "$i\t$short_pair[$i]\n" 	}
	
	print PE_out "panel: $panel_no; Long reads:\n";
	for $i (0..@long_pair) { 		print PE_out "$i\t$long_pair[$i]\n" 	}
	
	print PE_out "panel: $panel_no; Unpaired reads:\n";
	for $i (0..@unpair_pair) { 		print PE_out "$i\t$unpair_pair[$i]\n" 	}
	
	return ();
} # End sub PE_read


sub read_anno # for "E. coli" like files extracted from genBank
{
	while (<Anno>) {
		@anno_read = split ('\t', $_);
		push (@anno, [ @anno_read ] );
		if ( $anno_read[0] > ( $panel_no + 1 ) * $panel_width  ) {
			return()
		}
	}
	# This fix returns a large value, that will stop the anno read loop
	$anno_read[0] = $start_no + $panel_width + $chr_size ;
	push (@anno, [ @anno_read ] );
	return() # end of file?
} #end sub read_anno


sub read_SNP
{
	my $r=$_[0];
	while (<SNP_bed>) {
		next if /^#/;
		my @SNP = split "\t", $_;
		push (@SNP_bed, [@SNP]);
		# Read all SNP's at once  # if ( $r > 100 ) { return() ;  }
		$r++;
	}
	$SNP[1] = $start_no + $panel_width + $chr_size ;  #FIX
	push (@SNP_bed, [@SNP]);
	return() # end of file?
} #end sub read_SNP


sub print_read_density
{
	$density = 	"";
	my @density = @_;
	for ($i = 0; $i < $panel_width; $i++) {
		if ($density[$i] > 9 ) {
			if ($density[$i] > 35 ) {
				$density[$i] = "~"
			}
			else {
				$density[$i] = chr($density[$i]+87)
			}
		}
	}
	$density = join ("", @density);
	return() #
}		# sub print_read_density

					
sub push_qual
{
	$point = $_[1];
	$ID_qual[$point][$point_count[$point]] =  join "\t", @_;
	$point_count[$point]++;
	return()	
}  # sub push_qual


sub Check_translation_print  # Check all annotations in both directions; ? can be used for an unknown aa and will escape check since it is a ^\w.
{
	for $i ( 0 .. $info_lineno ) {
		if ( $a_p[$i]=~  /\S+/) {
			if ( $a_p[$i] =~ /\,(\w)\./) {			# forward direction
				while ( $a_p[$i] =~ /\,(\w)\./g ) {
					my $y =  pos($a_p[$i])-3;
					my $c_aa = $1 ;
					my $c_seq = substr ( $seqpr, $y, 3 ) ;
					my $c_trl = translate ($c_seq);
					if ( $c_aa ne $c_trl ) {
						print AUX_Report "ERROR in translation: $ap;  PN: $panel_no;  Pos:  $y +\t; Annot aa: $c_aa;  Found aa:  $c_trl \n";
					}
				}
			}
			if ( $a_p[$i] =~ /\.(\w)\,/) {			# reverse direction
				while ( $a_p[$i] =~ /\.(\w)\,/g ) {
					my $y =  pos($a_p[$i])-3;
					my $c_seq = revComp ( substr ( $seqpr, $y, 3 )) ;
					my $c_trl = translate ($c_seq);
					my $c_aa = $1 ;
					if ($c_aa ne $c_trl ) {
						print AUX_Report "ERROR in translation: $ap;  PN: $panel_no;  Pos:  $y -\t; Annot aa: $c_aa;  Found aa:  $c_trl \n";
					}
				}
			}
		}
	}
}

sub translate
{
	my $trsq = lc $_[0];
	my $traa = "";
	if ( $trsq =~ /tt[tc]/i )   {$traa = "F" }
	if ( $trsq =~ /tt[ag]/i )   {$traa = "L" }
	if ( $trsq =~ /tc./i )      {$traa = "S" }
	if ( $trsq =~ /ta[tc]/i )   {$traa = "Y" }
	if ( $trsq =~ /ta[ag]/i )   {$traa = "*" }
	if ( $trsq =~ /tg[tc]/i )   {$traa = "C" }
	if ( $trsq =~ /tga/i )      {$traa = "*" }
	if ( $trsq =~ /tgg/i )      {$traa = "W" }

	if ( $trsq =~ /ct./i )      {$traa = "L" }
	if ( $trsq =~ /cc./i )      {$traa = "P" }
	if ( $trsq =~ /ca[tc]/i )   {$traa = "H" }
	if ( $trsq =~ /ca[ag]/i )   {$traa = "Q" }
	if ( $trsq =~ /cg./i )      {$traa = "R" }

	if ( $trsq =~ /at[atc]/i )  {$traa = "I" }
	if ( $trsq =~ /atg/i )      {$traa = "M" }
	if ( $trsq =~ /ac./i )      {$traa = "T" }
	if ( $trsq =~ /aa[ct]/i )   {$traa = "N" }
	if ( $trsq =~ /aa[ag]/i )   {$traa = "K" }
	if ( $trsq =~ /ag[ct]/i )   {$traa = "S" }
	if ( $trsq =~ /ag[ag]/i )   {$traa = "R" }

	if ( $trsq =~ /gt./i )      {$traa = "V" }
	if ( $trsq =~ /gc./i )      {$traa = "A" }
	if ( $trsq =~ /ga[ct]/i )   {$traa = "D" }
	if ( $trsq =~ /ga[ag]/i )   {$traa = "E" }
	if ( $trsq =~ /gg./i )      {$traa = "G" }

	return($traa)	;
} # end sub translate


sub initialize_html
{  # Intialize left margins, font colors and html bit's & pieces
	
	$left_margin = 15;
	$LSP = " " x $left_margin  ; 	# LeftSPace: An empty space to create a left margin with
	$hr_width = ($panel_width+$left_margin)*8;
	$hr = "<HR size=2 color='#8888FF' width = '$hr_width' align = 'left'>";# '$hr_width'
	
	$fc1 = "<font color=#009000>";
	$fc2 = "<font color=#000090>";
	$fc3 = "<font color=#606000>";
	$fc4 = "<font color=#600060>";
	$fc_red = "<font color=#ff0000>";
	$f_end = "</font>";
	$bold  = "<b><font color=#FF3333>";
	$bold_ = "</b></font>";

	$HTML_P_rds      = $fc1."  +Rds"    . " " x ($left_margin - 6 );           # P: plus & M: minus strands
	$HTML_M_rds      = $fc2."  -Rds"    . " " x ($left_margin - 6 );           # rds: matching reads
	$HTML_P_rds_sum  = $fc1."  SUM+Rds" . " " x ($left_margin - 9 );    # SUM: sum or summaric presentation
	$HTML_M_rds_sum  = $fc2."  SUM-Rds" . " " x ($left_margin - 9 );
	$HTML_P_MMrds    = $fc1."  +MID"    . " " x ($left_margin - 6 );         # MID: Mutation's & InDel's
	$HTML_M_MMrds    = $fc2."  -MID"    . " " x ($left_margin - 6 );
	$HTML_Prds_sum   = $fc1."  SUM+MID" . " " x ($left_margin - 9 );
	$HTML_Mrds_sum   = $fc2."  SUM-MID" . " " x ($left_margin - 9 );
	$HTML_Anno       = $fc3."  Annot"   . " " x ($left_margin - 7 );
	$HTML_Repeat     = $fc4."  Repeat"  . " " x ($left_margin - 8 );
	$HTML_Cover      = $fc4."  Coverage" . " " x ($left_margin - 10 );    # Coverage & Quality are mixed together
	$HTML_SNP        = $fc4."  SNP"     . " " x ($left_margin - 5 );
	$HTML_PESp       = $fc1."  PE+ short" . " " x ($left_margin - 11 );
	$HTML_PESm       = $fc2."  PE- short" . " " x ($left_margin - 11 );
	$HTML_PELp       = $fc1."  PE+ long" . " " x ($left_margin - 10 );
	$HTML_PELm       = $fc2."  PE- long" . " " x ($left_margin - 10 );
	$HTML_PEU        = $fc1."  PE unpaired" . " " x ($left_margin - 13 );

	$h_hr_s1 = '<a href="';
	$h_hr_s2 = '<a href="html/';
	$h_hr_s3 = '<a id="';	
	$h_hr_s8 = '" >' ;
	$h_tb_s9 = '" target = "blank" >' ;
	$h_hr_e1 = '</a>';
	
}   #End sub initialize_html

sub sub_str	# Helps to identify "Substring out of range" errors; place a copy of the substring line and edit substring to sub_str
            # modify variables to suit and perhaps print to a tst file.
{
	my @sub = @_;
	unless ($sub[1] >= 0 && $sub[1] <= length  $sub[0] ) {
		$sub_l = length $sub[0];
		print "Substring error identification
		Substr error in panel: $panel_no;
		PosCorr: $pos_corr;
		MUT_0: $mut[0][0];
		PH: $ph; MP_c: $MP_corr[$ph];
		MH: $mh; MM_c: $MM_corr[$mh];
		xh: $xh
		xq: $xq
		$sub_l, 
		$sub[0]; $sub[1]; $sub[2]; $sub[3];
		
SP: $panel_PE_short_Plus[$i]; $sh_pair[0]; $pos_corr; length($sh_pair[2]..$sh_pair[3]); $sh_pair[2]..$sh_pair[3] );  # Prepare print PE read
		
UP: $un_pair;;
		\n";
		
		for $i ( 0 .. @unpair_pair) {
		#	print "$i; $unpair_pair[$i]\n"
		}
		
$sub_on = "true";
		# exit;
	}
	return ($sub);
} # end sub sub_str

sub max
{
	my @r= sort {$b <=> $a} (@_);
	return  $r[0];
} #max

sub revComp
{
	my $r=reverse($_[0]);
	$r=~tr/ACGTacgtNn/TGCAtgcaNn/;
	return  $r;
} #revComp

sub Comp
{
	my $r=($_[0]);
	$r=~tr/ACGTacgtNn/TGCAtgcaNn/;
	return  $r;
} #Comp

sub sub_print_No {
	my $No = $_[0];
	my $No_l = (length $No) -1;
	my $t_3 = - int ($No_l / 3) - 1;
	my $No_pr = "";
	while ( $t_3 < 0 ) {
		$No_pr .= substr ($No, 3*$t_3,3).",";
		$t_3++;
	}
	chop $No_pr;
	return($No_pr);
} # END sub sub_print_No

sub tid
{
	use Time::localtime;
	$tm = localtime;
	($Hr, $Min, $Sec) = ($tm -> hour, $tm -> min, $tm -> sec);
	$tid = sprintf("%02d:%02d:%02d",$Hr, $Min, $Sec);
	return()
} #end sub tid

sub Date
{
	use Time::localtime;
	$tm = localtime;
	($Day, $Month, $Year) = ($tm -> mday, $tm -> mon, $tm -> year);
	$date = sprintf("%02d-%02d-%02d",$Day, $Month+1, $Year+1900);
	return()
} #end sub Date

print "$tid   Program completed\n";
