#!/usr/bin/perl

# This script reformat reads in FASTQ format to SLXA format seqpre & qraw. Quality base is unchanged

#
#    Copyright 2010, 2011 Ole Skovgaard.
#    The scripts are distributed under the terms of the GNU General Public License
#
#
#    This file is part of R2R - From Read to Results.
#
#    R2R is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, version 3 of the License.
#
#    R2R is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with R2R.  If not, see <http://www.gnu.org/licenses/>.
#
#    Version: Release_0.950, April, 2011
#

#!/usr/bin/perl

$file_seq=$ARGV[0];

unless (open(test,"<$file_seq"))  { 
print "Input fastq file to be converted\n\n" ;
$file_seq=<stdin>;
chomp $file_seq;
}
close test;


open(f_seq,"<$file_seq") or die "No Sequence file: $file_seq";
$file_seq =~ /(\w+)/;
$fid_core = $1;
$s_out = $fid_core."_seqpre" ;
$q_out = $fid_core."_qraw";
open s_out,">$s_out";
open q_out,">$q_out";

tid();
print "Start:$tid \nSequence file to be converted: $file_seq \nResults will be in $s_out and in $q_out\n\n";

binmode out;   # Ensures that System independent Unix "LF" (0A) is used for New Line.
$CR = chr(10);

	$go_on = "true";
	$r_no{total} = 0;
	
	while ($go_on) {
		@read  ="";
		$empty  = <f_seq> or goto finish;
		$line++;
		unless ($empty =~/^\@(\S+)/) {die "error in $file_seq, line $line; line did not start with \"\@\" ";}
		$read[0] = $1."\t".lc <f_seq> or goto finish;
		$line++;
		$empty  = <f_seq> or goto finish;
		$line++;
		unless ($empty =~/^\+/) {die "error in $file_seq, line $line; line did not start with \"\@\"";}
		$read[1] = <f_seq> or goto finish;
		$line++;
		# chomp ($read[0],$read[1]);
			
		if ($go_on) { 
			print s_out $read[0]; 
			print q_out $read[1]; 
			$r_no{total}++
			}
	}
	
finish:

tid();
print "
*********************
End: $tid
Number of reads: $r_no{total}
Check that both Seq and Qual are empty below of here:
Seq:  $read[0]
Qual: $read[1]
*********************
";

sub tid
{
	use Time::localtime;
	$tm = localtime;
	($Hr, $Min, $Sec) = ($tm -> hour, $tm -> min, $tm -> sec);
	$tid = sprintf("%02d:%02d:%02d",$Hr, $Min, $Sec);
	return()
} #end sub tid

sub Date
{
	use Time::localtime;
	$tm = localtime;
	($Day, $Month, $Year) = ($tm -> mday, $tm -> mon, $tm -> year);
	$date = sprintf("%02d-%02d-%02d",$Day, $Month+1, $Year+1900);
	return()
} #end sub Date

