#!/usr/bin/perl

#    
#    Copyright 2010, 2011 Ole Skovgaard.
#    The scripts are distributed under the terms of the GNU General Public License
#    
#    
#    This file is part of R2R - From Read to Results.
#
#    R2R is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, version 3 of the License.
#
#    R2R is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with R2R.  If not, see <http://www.gnu.org/licenses/>.
#
#    Version: Release_0.950, November, 2011
#

open (GI,"<Genome_Index.ini" )or die "No Genome_Index.ini file found";
@OS_pipe = <GI>;
for $i ( 0 .. @OS_pipe-1 ) {
	@OS = split "\t",$OS_pipe[$i];
	$OS[0] =~ /(\$\w+)\s*=\s*([-\w\.\:\ \\\/]+)/;
	# Files:
	if ( $1 eq "\$chr" )                { push (@chr,$2) }
	if ( $1 eq "\$start_no" )           { push (@start_no,$2) }
	# General Variables:
	if ( $1 eq "\$name" )               { $name = $2 }
	if ( $1 eq "\$rd_length" )          { $rd_length = $2 }
	if ( $1 eq "\$index_dublicates" )   { $index_dublicates = $2 }
}

close GI;
#Checking input parameters:
foreach $chr(@chr) {
	open $chr,"<$chr";
	$_ = <$chr>;
	unless ( $_ =~ />/ ) {
		print "\nPosible error:\nFirst line of \'$chr\' is:\n$_\n - are you sure that \'$chr\' is a Fasta formatted sequence file? yes/no:\n";
		my $rc = <stdin>;
		unless ($rc =~ /y/i ) {print "Try again, correct the \"Genome_Index.ini\" file \nso that \$chr is set to Fasta file(s)\nand no empty lines follows\n"; exit}
	}
	close $chr;
}
for $i(0..@start_no-1) {
	if ( $start_no[$i] =~ /\D+/ ) {
		my $j = $i+1;
		print "\nPosible error:\n$j\' start_no for chromsome \'$chr[$i]\' is: $start_no[$i]\n - are you sure that this is correct? yes/no:\n";
		my $rc = <stdin>;
		unless ($rc =~ /y/i ) {print "Try again, correct the \"Genome_Index.ini\" file \nso that each \'\$start_no\' is set to number(s)\nand no empty lines follows\n"; exit}
	}
}
my $c = @chr ; my $s = @start_no; 
unless ($c == $s) {
	print "\nError:\nNumber of \$chr\'s does not match number of \$start_no\'s in the \"Genome_Index.ini\" file:\n";
	$i = 0;
	while ( $chr[$i] or $start_no[$i] ) {
		$i++;
		print "  The $i\' \$start_no for $i\' \$chr: \'$chr[$i-1]\' is set to \'$start_no[$i-1]\';\n";
	}
	print "Try again, correct the \"Genome_Index.ini\" file \nso that each \$start_no matches each \$chr \nand no \$start_no nor \$chr lines are followed by an empty line\n"; exit;
}
unless ($name) {
		print "\nError:\nNo \$name given for this index, correct the \"Genome_Index.ini\" file \nOne line should read: \"\$name = something; \"\n"; exit;
}
if ($rd_length =~ /\D+/ ) {
		print "\nError:\n\$rd_length is set to: \"$rd_length\" \n\$rd_length must be a valid number, correct the \"Genome_Index.ini\" file \nOne line should read: \"\$rd_length = \"a number\"; \"\n"; exit;
}

$screen = select (); # Saves the value for default output (to the screen), used after flushing of output files.
binmode out;   # Ensures that System independent Unix "LF" (0A) is used for New Line.

#			open(tst1, ">test1.txt");
#			open(tst2, ">test2.txt");		
#
#			select (tst1);    $| = 1;     # Don't buffer print
#			select (tst2);    $| = 1;     # Don't buffer print  

select ($screen);

open unsort,">$name.usrt.temp";
open sort_out,">$name.srt_seqs";
open(discarded,">$name.discarded_seqs");
open(GI_report,">$name.GI_report");

tid();
$tid_start = $tid;

if ( $^O =~ /Win/) { 	$platform = "DOS" } else  { $platform = "Linux/Unix" } # System?
print "\n$tid: Start   System is: $platform \n";

#Read and distribute In files:
for $i ( 0 .. @chr-1 ) {
	$s_no[$i] = $b_no[$i] = $start_no[$i];  #	$b_no[$i];  first base number for each chromosome
	$endof = "";
	$chromosome = "chromosome".$i;
	open($chromosome,"<$chr[$i]") or die "Can't open Chromosome$i in file $chr[$i]"  ;
	$chr_id[$i] = <$chromosome>;   # First line of fasta file
	$chr_id[$i] =~ /(\w+)\s+(\d+)/;
	$chr_name[$i] = $1;
	$chr_length[$i] = $2;
	$circular[$i] = "No";
	if ( $chr_id[$i] =~ /circular/) {
		$seq = "";
		read_seq();
		$first_seq = substr ($seq, 0, $rd_length-1) ;
		$circular[$i] = "Yes, sequence: $first_seq is added to the end";		
		$seq = "";
	}
	close $chromosome;
	print "\nSequence of $chr[$i] will be distributed for indexing
	Circular? $circular[$i] \nChopping $chr[$i]: \n" ;
	open($chromosome,"<$chr[$i]") or die "Can't open Chromosome$i in file $chr[$i]"  ;
	$seq = "";
	$endof = "";
	read_seq();

	while (length ($seq) >= $rd_length ) {
		unless ($endof) {		
			if (length ($seq) <= $rd_length ) { read_seq()}
		}
		$bn = sprintf ("%9d", $b_no[$i]);
		$rd_seq = substr($seq, 0, $rd_length);
		$out = "unsort";
		if ($rd_seq =~ /[^acgt]/){$out = "discarded"; $discarded++}
		print $out "$rd_seq\t$chr[$i]\t$bn\t+\n";
		$rd_seq = revComp($rd_seq);
		print $out "$rd_seq\t$chr[$i]\t$bn\t-\n";
		$seq =~ s/[acgtnmwrsyk]// ; #truncates $seq with one base only
		$b_no[$i]++;
	}	
	$b_no[$i]--;	
	$xend = $b_no[$i] + $rd_length - length ($first_seq);
	$chr_length_found[$i] = $xend-$s_no[$i];	
	$x = $i+1; 
	tid();
	print "$tid: $x' Chromosome $chr[$i] starts at: $s_no[$i]; and ends at: $xend \n";	
	close ($chromosome);
}

# Sorting index-sequences alphabetically
select (unsort);  $| = 1;  $| = 0;   # Flush
select ($screen);
close unsort;
tid();  
$tid_sort1_start = $tid;
$sort_in = "$name.usrt.temp";
$sort_out = "$name.srt.temp";
print "$tid Sorting index-sequences in: \n           $sort_in \n         to: \n           $sort_out \n\n";
if ($platform eq "DOS" ) {
	system ("sort $sort_in /O $sort_out /L C");
}
else {
	system ("sort $sort_in > $sort_out"); 
}
tid();  
$tid_sort1_end = $tid;
print "$tid Sorting finished\n\n         Starting repeat-sequence analysis\n";

if ($index_dublicates) {   # removes repeated index-sequences and annotates the remaining index-sequence.
	# Writing repeat files in .csv format
	for $i (0 .. @chr-1) {
		$opn = "$name.$chr[$i].rep.temp";
		open ($chr[$i],">$opn");
	}
	open Srt_Reads,"<$sort_out";
	while (<Srt_Reads>) {
		chomp;
		$ref_read = $_;
		@ref_idx = split "\t",$_;		
		if ($ref_idx[0] eq $ref_idx_prev[0] ){
			$repeat = "true"; 					
			for $i (1..3) {   # for mapping read to multible sites, part of PE mapping
				push @ref_idx_prev,$ref_idx[$i];
			}			
			push @repeat,$ref_read;						
			unless ($repeat_prev) { push @repeat,$ref_read_prev }
		}
		else {
			$repeat = "";
		}		
		unless ($repeat) { 
			if ($ref_read_prev) {
				$out = join "\t", @ref_idx_prev;
			#	if ($out) {
					print sort_out "$out\n";
			#		}
			}			
			if (@repeat) {  # i.e @ contains repeat information
				foreach $repeat(@repeat) {
					@out_file = split "\t",$repeat;
					if ($out_file[3] eq "+" ) {
						$out_file = "$out_file[1]";
						$out_rep = join "\t", $out_file[2],$out_file[1],$out_file[0],$out_file[3];
						print $out_file "$out_rep\n";
					}
				}								
				@repeat ="";
				}
			@ref_idx_prev = @ref_idx;
			$ref_read_prev = $ref_read;
			$repeat_prev = $repeat;
		}
	}		# End  while (<Srt_Reads>) 
	close Srt_Reads, sort_out;
	
	for $i (0 .. @chr-1) { 
		close $chr[$i]; 	
		tid();  
		$sort_in  = "$name.$chr[$i].rep.temp";
		$sort_out = "$name.$chr[$i].rep_srt.temp";
		print "$tid Sorting repeat-sequences in:\n           $sort_in\n         to:\n           $sort_out \n";
		if ($platform eq "DOS" ) {
			system ("sort $sort_in /O $sort_out /L C");
		}
		else {
			system ("sort -n $sort_in > $sort_out"); 
		}
		tid(); 
		print "$tid Sorting finished\n\n";		
		open Rep_Read, "<$sort_out";
		open Rep_Out, ">$name.$chr[$i].repeat.csv";
		$rep_start = $rep_end = "";
		while (<Rep_Read>) {
			@rep_ref = split "\t";
			if ($rep_ref[0] < $rep_end) {
				$rep_extend = "true";
				$rep_end   = $rep_ref[0] + $rd_length;
			}
			else {
				$rep_extend = "";
				if ($rep_start) { print Rep_Out "$rep_start	$rep_end	\n"; }
			}
			unless ($rep_extend) {
				$rep_start = $rep_ref[0];			# $rep_start is defined as the first repeated base
				$rep_end   = $rep_ref[0] + $rd_length;	# $rep_end is defined as the first not-repeated base
			}
		}
		if ($rep_start && $rep_extend) { print Rep_Out "$rep_start	$rep_end	\n"; }
		close Rep_Read,Rep_Out;
	} # End 	for $i (0 .. @chr-1) 	
}	# End if ($index_dublicates)

if ($platform eq "DOS" ) { #deletes temporary files;
	system ("del *.temp");
}
else {
	system ("rm *.temp"); 
}

tid();
Date();
print GI_report "Program:             $0
Date: $date     Time: $tid_start.

Parameters are set in the Genome_Index.ini file (see all parameters below)
Sequence files:      @chr
Sequence name:       $name
Read length:         $rd_length \n";
for $i ( 0 .. @chr-1 ) {
	$seqs_no[$i] = ($circular[$i] eq "No"? $b_no[$i] - $s_no[$i] - $rd_length: $b_no[$i] - $s_no[$i]);
	print GI_report "\nFirst line for Chromosome $i:\n$chr_id[$i]   Chromosome: $chr[$i]\tLength reported: $chr_length[$i] bp\tLength found: $chr_length_found[$i] bp\n   No of Srt Seqs:  $seqs_no[$i] x 2\n\n";
	$seqs_no += $seqs_no[$i] * 2;
}

print GI_report "
Total No of Srt Seqs:      $seqs_no
Discarded seqs:            $discarded
Analysis started at:       $tid_start
Analysis finished at:      $tid


Outfiles:
Sorted sequences in:       $name.srt_seqs
Discarded sequences in:    $name.discarded_seqs
Repeat trace for each chr: $rep_string_out

All parameters set in the Genome_Index.ini file:
------------------------------------------------
@OS_pipe
";
close GI_report;

print "$tid: Genome indexing finished;\n";
# end


sub read_seq
{
	my $r=$_[0];
	while (<$chromosome>) {
		s/\s//;
		s/\d+//;
		if ($_ =~/^([acgtnmwrsyk]+)/i) {$seq = $seq . lc($1);}
		if ( $r > 1000 ) { 	return(); }
		$r++;
	}
	unless ($first_seq eq "No") {		
		unless ($endof) {	
			$seq = $seq.$first_seq; 
		}
	}  # for circular chromosomes	
	$endof = "truex";
	return() # end of file?
} #end sub read_seq

sub revComp
{
	my $r=reverse($_[0]);
	$r=~tr/ACGTacgtNnRrYy/TGCAtgcaNnYyRr/;
	return  $r;
} #revComp

sub tid  # The Danish word "tid" is used instead of "time", to confuse UltraEdit
{
	use Time::localtime;
	$tm = localtime;
	($Hr, $Min, $Sec) = ($tm -> hour, $tm -> min, $tm -> sec);
	$tid = sprintf("%02d:%02d:%02d",$Hr, $Min, $Sec);
	return()
} #end sub tid

sub Date
{
	use Time::localtime;
	$tm = localtime;
	($Day, $Month, $Year) = ($tm -> mday, $tm -> mon, $tm -> year);
	$date = sprintf("%02d-%02d-%02d",$Day, $Month+1, $Year+1900);
	return()
} #end sub Date
